#include <stdio.h>
#include <gtk/gtk.h>
#include "../Misc/my_dbug.h"
#include "eval_global.h"
#include "ml_limits.h"


gboolean 
isIntBetweenLimits(gdouble value)
{
  gboolean res;

  DBUG_ENTER("isIntBetweenLimits");

  if ((MIN_ML_INT <= value) && (value <= MAX_ML_INT)) {
    res = TRUE;
  } else {
    res = FALSE;
    //printf("value: %f\tMIN_ML_INT: %f\n", value, MIN_ML_INT);
    if (value < MIN_ML_INT) {
      runtime_error("integer underflow");
    } else {
      //MAX_ML_INT < value
      runtime_error("integer overflow");
    }
  }

  DBUG_RETURN(res);
} //isIntBetweenLimits


gboolean 
isRealBetweenLimits(gdouble value)
{
  gboolean res;

  DBUG_ENTER("isRealBetweenLimits");

  if ((-G_MAXDOUBLE <= value) && (value <= G_MAXDOUBLE)) {
    res = TRUE;
  } else {
    res = FALSE;
    printf("value: %e\tG_MINDOUBLE: %e\tG_MaxDOUBLE: %e\n", 
	   value, G_MINDOUBLE, G_MAXDOUBLE);
    if (value < G_MINDOUBLE) {
      runtime_error("real underflow");
    } else {
      //G_MAXDOUBLE < value
      runtime_error("real overflow");
    }
  }

  DBUG_RETURN(res);
} //isRealBetweenLimits
