#ifndef _DRAWABLE_EXPR_H
#define _DRAWABLE_EXPR_H



#include <gtk/gtk.h>
#include "../Syntaxtree/syntaxtree.h"
#include "kiel_global.h"

typedef struct _Drawable_expr_struct {
  Expr_node_ptr initial_expr;
  Expr_node_ptr act_expr;
  gint          expr_height; //longest path from root to a leaf
  GList*        redo_list;
  GList*        undo_list;
  gint          totalPixelwidth;
  gint          totalPixelheight;
  gboolean      drawingAllowed;
} Drawable_expr_struct, *Drawable_expr_ptr;


extern Drawable_expr_ptr 
create_drawable_expr(Expr_node_ptr pAct_expr);

extern void 
free_drawable_expr(Drawable_expr_ptr pDrawExpr);

extern gint 
getExprPixelmiddle_x(Expr_node_ptr pExpr);

extern gint 
getExprPixelmiddle_y(Expr_node_ptr pExpr);

extern gint 
getExprPixelheight(Expr_node_ptr pExpr, BAUMFENSTER_TYP bmf);

//extern gint 
//getTotalPixelwidth(void);

//extern gint 
//getTotalPixelheight(void);

extern gboolean 
isDrawableNode(Expr_node_ptr pExpr);

extern void 
set_WethSha_parameters(gint min_delta_x, gint delta_y, gint DEN_height);

extern void 
prepareForWethSha(Drawable_expr_ptr pDrawExpr);

extern void 
wetherellShannon(Drawable_expr_ptr pDrawExpr, BAUMFENSTER_TYP bmf);

extern void 
drawDrawableExpr(Drawable_expr_ptr pDrawExpr, Expr_node_ptr markedNode, 
		 BAUMFENSTER_TYP bmf);
/****
extern Expr_node_ptr 
findClickedNode(Expr_node_ptr pExpr, gint mouse_x, gint mouse_y, 
		BAUMFENSTER_TYP bmf);
****/
extern void 
findClickedNodeAndParent(Expr_node_ptr root, gint mouse_x, gint mouse_y,
			 BAUMFENSTER_TYP bmf, Expr_node_ptr* refClickedNode, 
			 Expr_node_ptr* refParent_of_node);

extern void 
calcPixelwidthAndHeight(Drawable_expr_ptr pDrawExpr, BAUMFENSTER_TYP bmf);



#endif //_DRAWABLE_EXPR_H
