#include "kiel_global.h"

#include "kiel_gtk.h"
#include "kiel_gtk_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk_aef.h"  /* Ausdruckeingabe-Fenster */
#include "kiel_gtk_bmf.h"  /* Baum-Fenster */
#include "kiel_gtk_zrf.h"  /* Zeichenreihen-Fenster */
#include "kiel_gtk_awf.h"  /* Auswertungs-Fenster */
#include "kiel_gtk_bf.h"   /* Befehls-Fenster */
#include "kiel_gtk_df.h"   /* Datei-Fenster */
#include "kiel_gtk_wf.h"   /* Warnungs-Fenster */
#include "kiel_gtk_uef.h"  /* bersichts-Fenster */
#include "kiel_gtk_urf.h"  /* Undoredo-Fenster */

#include "window_options.h"

  #include "kiel_fkt.h"

#include "kiel_ressource.h"
#include "../Misc/error_interface.h"
#include "../Syntaxtree/syntaxtree.h"
#include "../Syntaxtree/st_io.h"
#include "drawable_expr.h"


void Baumfenster_Toggle_Button_an()
{
  kiel_debug_in(10,"Baumfenster_Toggle_Button_an");

  gtk_toggle_button_set_state(
    GTK_TOGGLE_BUTTON(befehlsfenster->button_ausdruckbaum), 1);
  //calls indirectly 'befehlsfenster_button_press_callback' from kiel_gtk_bf.c

  kiel_debug_out(10,"Baumfenster_Toggle_Button_an");
}


void Baumfenster_Toggle_Button_aus()
{
  kiel_debug_in(10,"Baumfenster_Toggle_Button_aus");

  gtk_toggle_button_set_state(
    GTK_TOGGLE_BUTTON(befehlsfenster->button_ausdruckbaum), 0);

  kiel_debug_out(10,"Baumfenster_Toggle_Button_aus");
}


void ADK_Uebersichtsfenster_Toggle_Button_an()
{
  kiel_debug_in(10,"ADK_Uebersichtsfenster_Toggle_Button_an");

  gtk_toggle_button_set_state(
                    GTK_TOGGLE_BUTTON(befehlsfenster->button_adkuebersicht),1);

  kiel_debug_out(10,"ADK_Uebersichtsfenster_Toggle_Button_an");
}


void ADK_Uebersichtsfenster_Toggle_Button_aus()
{
  kiel_debug_in(10,"ADK_Uebersichtsfenster_Toggle_Button_aus");

  gtk_toggle_button_set_state(
                    GTK_TOGGLE_BUTTON(befehlsfenster->button_adkuebersicht),0);

  kiel_debug_out(10,"ADK_Uebersichtsfenster_Toggle_Button_aus");
}


void RV_Uebersichtsfenster_Toggle_Button_an()
{
  kiel_debug_in(10,"RV_Uebersichtsfenster_Toggle_Button_an");

  gtk_toggle_button_set_state(
                     GTK_TOGGLE_BUTTON(befehlsfenster->button_rvuebersicht),1);

  kiel_debug_out(10,"RV_Uebersichtsfenster_Toggle_Button_an");
}


void RV_Uebersichtsfenster_Toggle_Button_aus()
{
  kiel_debug_in(10,"RV_Uebersichtsfenster_Toggle_Button_aus");

  gtk_toggle_button_set_state(
                     GTK_TOGGLE_BUTTON(befehlsfenster->button_rvuebersicht),0);

  kiel_debug_out(10,"RV_Uebersichtsfenster_Toggle_Button_aus");
}


void Undo_Redofenster_Toggle_Button_an()
{
  kiel_debug_in(10,"Undo_Redofenster_Toggle_Button_an");

  gtk_toggle_button_set_state(
                         GTK_TOGGLE_BUTTON(befehlsfenster->button_undoredo),1);

  kiel_debug_out(10,"Undo_Redofenster_Toggle_Button_an");
}


void Undo_Redofenster_Toggle_Button_aus()
{
  kiel_debug_in(10,"Undo_Redofenster_Toggle_Button_aus");

  gtk_toggle_button_set_state(
                         GTK_TOGGLE_BUTTON(befehlsfenster->button_undoredo),0);

  kiel_debug_out(10,"Undo_Redofenster_Toggle_Button_aus");
}


void Auswertungsfenster_Toggle_Button_aus()
{
  kiel_debug_in(10,"Auswertungsfenster_Toggle_Button_aus");

  gtk_toggle_button_set_state(
                       GTK_TOGGLE_BUTTON(befehlsfenster->button_auswertung),0);

  kiel_debug_out(10,"Auswertungsfenster_Toggle_Button_aus");
}


void Zeichenreihenfenster_Toggle_Button_aus()
{
  kiel_debug_in(10,"Zeichenreihenfenster_Toggle_Button_aus");

  gtk_toggle_button_set_state(
                     GTK_TOGGLE_BUTTON(befehlsfenster->button_zeichenreihe),0);

  kiel_debug_out(10,"Zeichenreihenfenster_Toggle_Button_aus");
}


void setze_statuslabel(gchar *s)
{
  kiel_debug_in(10,"setze_statuslabel");

  gtk_label_set_text(GTK_LABEL(baumfenster->statuslabel),s);
  while (gtk_events_pending()) gtk_main_iteration();

  kiel_debug_out(10,"setze_statuslabel");
}


void 
UndoRedo_ProgressBar_und_MaxLabel_aktualisieren(Drawable_expr_ptr pDrawExpr)
{
  gint akt,von,bis;
  gchar *neuer_labeltext;

  kiel_debug_in(10,"UndoRedo_ProgressBar_und_MaxLabel_aktualisieren");

  if (pDrawExpr) {
    akt = g_list_length(pDrawExpr->undo_list);
    von = 0;
    bis = akt + g_list_length(pDrawExpr->redo_list);
  } else {
    akt=0;
    von=0;
    bis=0;
  } 

  gtk_progress_configure(GTK_PROGRESS(undoredofenster->progressbar),
                         akt, von, bis);

  neuer_labeltext = g_strdup_printf("%d", akt);
  gtk_label_set(GTK_LABEL(undoredofenster->label_max_zurueck),neuer_labeltext);
  g_free(neuer_labeltext);

  neuer_labeltext = g_strdup_printf("%d", bis - akt);
  gtk_label_set(GTK_LABEL(undoredofenster->label_max_vor), neuer_labeltext);
  g_free(neuer_labeltext);

  kiel_debug_out(10,"UndoRedo_ProgressBar_und_MaxLabel_aktualisieren");
}


void Zeichenreihenlabel_aktualisieren()
{
  Drawable_expr_ptr pDrawExpr;
  gchar *neuer_labeltext;

  kiel_debug_in(10,"Zeichenreihenlabel_aktualisieren");

  pDrawExpr = hole_markierten_Ausdruck();
  if (pDrawExpr != NULL) {
    neuer_labeltext = exprNode2String(pDrawExpr->act_expr);
    gtk_label_set(GTK_LABEL(zeichenreihenfenster->zeichenreihen_label),
                  neuer_labeltext);
    mtfree(neuer_labeltext);
  } else {
    gtk_label_set(GTK_LABEL(zeichenreihenfenster->zeichenreihen_label), "");
  }

  kiel_debug_out(10,"Zeichenreihenlabel_aktualisieren");
}


void programm_verlassen_event(GtkWidget *widget,GdkEvent *event,gpointer *data)
{
  gint i;
  //GList **MLAdksP, *tmp;

  kiel_debug_in(10,"programm_verlassen_event");

  
  options_save();

  /* globale Variablen aufrumen */
  clear_ErrorDescription();
  loesche_MLAusdruecke();
  /*
  MLAdksP = hole_adresse_von_MLAusdruecke();
  for (tmp = *MLAdksP;  tmp != NULL;  tmp = g_list_next(tmp)) {
    free_drawable_expr(tmp->data);
    tmp->data = NULL;
  } //for tmp
  g_list_free(*MLAdksP);
  *MLAdksP = NULL;
  */
  /* Befehlsfenster */ 
  gtk_timeout_remove(befehlsfenster->timer_id);
  for(i=0;  i < 5;  i++) {
    mtfree(befehlsfenster->pixdraw[i]);
  } //for i
  mtfree(befehlsfenster);
  /* Baum-Fenster */
  if (baumfenster->pix_draw) mtfree(baumfenster->pix_draw);
  mtfree(baumfenster); 
  /* Zeichenreihen-Fenster */
  mtfree(zeichenreihenfenster);
  /* Ausdruck-bersichts-Fenster */
  mtfree(adkuebersichtsfenster);
  /* RV-bersichts-Fenster erzeugen */
  mtfree(rvuebersichtsfenster);
  /* Undo-Redo-Fenster */
  mtfree(undoredofenster);
  /* Ausdruckeingabe-Fenster */
  mtfree(ausdruckeingabefenster);
  /* Auswertungs-Fenster */
  mtfree(auswertungsfenster);
  /* Ausdrcke und Rechenvorschriften */
  /* werden beim Programmende automatisch gefreet. */
  free_symboltable(symbol_table);
  free_syntaxtree(syntax_tree);

  /* und Ende! */
  gtk_main_quit();
  
  /* Brutal, aber es mu sein! */
  mtshowtotals("befor gtk_exit");
  PRINTF_MTSLOTS;

  gtk_exit(0);
  kiel_debug_out(10,"programm_verlassen_event");
}


void auswertungs_abbruch_auf_true()
{
  kiel_debug_in(10,"auswertungs_abbruch_auf_true");

  ist_auswertungs_abbruch_erwuenscht = TRUE;
  eval_stats.userbreak = TRUE;

  kiel_debug_out(10,"auswertungs_abbruch_auf_true");
}


void auswertungs_abbruch_auf_false()
{
  kiel_debug_in(10,"auswertungs_abbruch_auf_false");

  ist_auswertungs_abbruch_erwuenscht=FALSE;
  eval_stats.userbreak = FALSE;

  kiel_debug_out(10,"auswertungs_abbruch_auf_false");
}


gboolean auswertungs_abbruch_erwuenscht()
{
  kiel_debug_in(10,"auswertungs_abbruch_erwuenscht");

  kiel_debug_out(10,"auswertungs_abbruch_erwuenscht");
  return(/*ist_auswertungs_abbruch_erwuenscht*/eval_stats.userbreak);
}


void habe_warnungs_fenster_geoeffnet()
{
  kiel_debug_in(10,"habe_warnungs_fenster_geoeffnet");

  anz_warnungs_fenster_geoeffnet++;

  kiel_debug_out(10,"habe_warnungs_fenster_geoeffnet");
}


void habe_warnungs_fenster_geschlossen()
{
  kiel_debug_in(10,"habe_warnungs_fenster_geschlossen");

  anz_warnungs_fenster_geoeffnet--;

  kiel_debug_out(10,"habe_warnungs_fenster_geschlossen");
}


gboolean warnungs_fenster_geoeffnet()
{
  kiel_debug_in(0,"warnungs_fenster_geoeffnet");

  kiel_debug_out(0,"warnungs_fenster_geoeffnet");
  return(anz_warnungs_fenster_geoeffnet>0);
}


void trotz_warnung_auf_true()
{
  kiel_debug_in(10,"trotz_warnung_auf_true");

  trotz_warnung_=TRUE;

  kiel_debug_out(10,"trotz_warnung_auf_true");
}


void trotz_warnung_auf_false()
{
  kiel_debug_in(10,"trotz_warnung_auf_false");

  trotz_warnung_=FALSE;

  kiel_debug_out(10,"trotz_warnung_auf_false");
}


gboolean trotz_warnung()
{
  kiel_debug_in(10,"trotz_warnung");

  kiel_debug_out(10,"trotz_warnung");
  return(trotz_warnung_);
}


/* Die folgenden hole_adresse_von_-Funktionen ermglichen es den            */
/* kiel_gtk_fenster-Programmen auf private globale Variable von kiel_gtk  */
/* zuzugreifen.                                                             */
GList **hole_adresse_von_MLAusdruecke()
{
  GList **erg;

  kiel_debug_in(10,"hole_adresse_von_MLAusdruecke");

  erg=&MLAusdruecke;

  kiel_debug_out(10,"hole_adresse_von_MLAusdruecke");
  return(erg);
}


void 
loesche_MLAusdruecke()
{
  GList **MLAdksP, *tmp;

  kiel_debug_in(10,"loesche_MLAusdruecke");

  MLAdksP = hole_adresse_von_MLAusdruecke();
  for (tmp = *MLAdksP;  tmp != NULL;  tmp = g_list_next(tmp)) {
    free_drawable_expr(tmp->data);
    tmp->data = NULL;
  } //for tmp
  g_list_free(*MLAdksP);
  *MLAdksP = NULL;

  kiel_debug_out(10,"loesche_MLAusdruecke");
  return;
}


/* auch kiel_adk braucht zum Parsen : */
GList **hole_adresse_von_MLRechenvorschriften()
{
  GList **erg;

  kiel_debug_in(10,"hole_adresse_von_MLRechenvorschriften");

  erg=&syntax_tree;

  kiel_debug_out(10,"hole_adresse_von_MLRechenvorschriften");
  return(erg);
}


BAUMFENSTER_TYP *hole_adresse_von_baumfenster()
{
  BAUMFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_baumfenster");

  erg=&baumfenster;

  kiel_debug_out(10,"hole_adresse_von_baumfenster");
  return(erg);
}


ZEICHENREIHENFENSTER_TYP *hole_adresse_von_zeichenreihenfenster()
{
  ZEICHENREIHENFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_zeichenreihenfenster");

  erg=&zeichenreihenfenster;

  kiel_debug_out(10,"hole_adresse_von_zeichenreihenfenster");
  return(erg);
}


BEFEHLSFENSTER_TYP *hole_adresse_von_befehlsfenster()
{
  BEFEHLSFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_befehlsfenster");

  erg=&befehlsfenster;

  kiel_debug_out(10,"hole_adresse_von_befehlsfenster");
  return(erg);
}


AUSDRUCKEINGABEFENSTER_TYP *hole_adresse_von_ausdruckeingabefenster()
{
  AUSDRUCKEINGABEFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_ausdruckeingabefenster");

  erg=&ausdruckeingabefenster;

  kiel_debug_out(10,"hole_adresse_von_ausdruckeingabefenster");
  return(erg);
}


UEBERSICHTSFENSTER_TYP *hole_adresse_von_adkuebersichtsfenster()
{
  UEBERSICHTSFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_adkuebersichtsfenster");

  erg=&adkuebersichtsfenster;

  kiel_debug_out(10,"hole_adresse_von_adkuebersichtsfenster");
  return(erg);
}


UEBERSICHTSFENSTER_TYP *hole_adresse_von_rvuebersichtsfenster()
{
  UEBERSICHTSFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_rvuebersichtsfenster");

  erg=&rvuebersichtsfenster;

  kiel_debug_out(10,"hole_adresse_von_rvuebersichtsfenster");
  return(erg);
}


UNDOREDOFENSTER_TYP *hole_adresse_von_undoredofenster()
{
  UNDOREDOFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_undoredofenster");

  erg=&undoredofenster;

  kiel_debug_out(10,"hole_adresse_von_undoredofenster");
  return(erg);
}


AUSWERTUNGSFENSTER_TYP *hole_adresse_von_auswertungsfenster()
{
  AUSWERTUNGSFENSTER_TYP *erg;

  kiel_debug_in(10,"hole_adresse_von_auswertungsfenster");

  erg=&auswertungsfenster;

  kiel_debug_out(10,"hole_adresse_von_auswertungsfenster");
  return(erg);
}


void GTK_Schleife(gint argc,gchar **argv)
{
  gchar *datname;
  FILE *dat;

  kiel_debug_in(10,"GTK_Schleife");

  gtk_init(&argc,&argv);

  /* Ressourcedateien laden */
  datname=g_strdup_printf("%s/.kiel.rc.gtk",g_get_home_dir());
  if ((dat=fopen(datname,"r"))==NULL) {
    datname=g_strdup_printf("%s/kiel.rc.gtk",g_dirname(argv[0]));
    gtk_rc_parse(datname);
  }
  else {
    fclose(dat);
    gtk_rc_parse(datname);
  }
  g_free(datname);

  datname=g_strdup_printf("%s/.kiel.rc",g_get_home_dir());
  if ((dat=fopen(datname,"r"))==NULL) {
    datname=g_strdup_printf("%s/kiel.rc",g_dirname(argv[0]));
    ressourcen_einlesen(datname);
  }
  else {
    fclose(dat);
    ressourcen_einlesen(datname);
  }
  g_free(datname);


  /* Befehlsfenster erzeugen */
  befehlsfenster=mtmalloc(sizeof(BEFEHLSFENSTER_STRUCT));
  erzeuge_Befehls_Fenster(befehlsfenster);

  /* Baumfenster erzeugen */
  baumfenster=mtmalloc(sizeof(BAUMFENSTER_STRUCT)); 
  erzeuge_Baum_Fenster(baumfenster);
 
  /* Zeichenreihenfenster erzeugen */
  zeichenreihenfenster=mtmalloc(sizeof(ZEICHENREIHENFENSTER_STRUCT)); 
  erzeuge_Zeichenreihen_Fenster(zeichenreihenfenster);
 
  /* Ausdruck-bersichts-Fenster erzeugen */
  adkuebersichtsfenster=mtmalloc(sizeof(UEBERSICHTSFENSTER_STRUCT));
  erzeuge_Uebersichts_Fenster(adkuebersichtsfenster,
                              UEBERSICHTSFENSTER_AUSDRUCK);
   
  /* RV-bersichts-Fenster erzeugen */
  rvuebersichtsfenster=mtmalloc(sizeof(UEBERSICHTSFENSTER_STRUCT));
  erzeuge_Uebersichts_Fenster(rvuebersichtsfenster,
                              UEBERSICHTSFENSTER_RECHENVORSCHRIFT);
  
  /* Undo-Redo-Fenster erzeugen */
  undoredofenster=mtmalloc(sizeof(UNDOREDOFENSTER_STRUCT));
  erzeuge_Undo_Redo_Fenster(undoredofenster);

  /* Ausdruck-Eingabe-Fenster erzeugen */
  ausdruckeingabefenster=mtmalloc(sizeof(AUSDRUCKEINGABEFENSTER_STRUCT));
  erzeuge_Ausdruckeingabe_Fenster(ausdruckeingabefenster);
 
  /* Auswertungs-Fenster erzeugen */
  auswertungsfenster=mtmalloc(sizeof(AUSWERTUNGSFENSTER_STRUCT));
  erzeuge_Auswertungs_Fenster(auswertungsfenster);

  /* Ausdrucks- und Rechenvorschriftsliste initialisieren */
  MLAusdruecke=NULL;
  syntax_tree=NULL;


  /* GTK-Hauptschleife */
  {
    kiel_debug_in(10,"gtk_main");
    
    if ( global_opt_read_prg != NULL ) { 
      Programm_Laden( global_opt_read_prg );
    }

    if ( global_opt_read_exp != NULL ) { 
      Ausdruck_Laden( global_opt_read_exp );
    }

    options_load();
    gtk_main();
    kiel_debug_out(10,"gtk_main");
  }

  kiel_debug_out(10,"GTK_Schleife");
}
