#include "kiel_global.h"

#include "kiel_gtk_awf.h"
#include "kiel_gtk_awf_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk_wf.h"
#include "kiel_gtk.h"

  #include "kiel_fkt.h"

#include "../Evaluator/eval_global.h"
#include "kiel_ressource.h"


EvalMode 
aktuelle_Auswertungsart(void)
{
  EvalMode erg = e_lmim;

  kiel_debug_in(10,"aktuelle_Auswertungsart");

  /* Da die drei Buttons zu einer Gruppe von Radiobutton gehren, ist genau */
  /* einer aktiv.                                                           */

  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_auswertungsart[0])->active)
    erg = e_lmim; //AUSWERTUNG_LEFTMOST_INNERMOST;
 
  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_auswertungsart[1])->active)
    erg = e_lmom; //AUSWERTUNG_LEFTMOST_OUTERMOST;

  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_auswertungsart[2])->active)
    erg = e_full; //AUSWERTUNG_FULL;

  kiel_debug_out(10,"aktuelle_Auswertungsart");
  return(erg);
}


gint 
aktuelle_Anzahl_Auswertungsschritte(void)
{
  gint erg = 1;
  gchar *text;

  kiel_debug_in(10,"aktuelle_Anzahl_Auswertungsschritte");

  /* Da die fnf Buttons zu einer Gruppe von Radiobutton gehren, ist genau */
  /* einer aktiv.                                                           */

  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[0])->active)
    erg = 1;
 
  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[1])->active)
    erg = 5;

  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[2])->active)
    erg = 10;

  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[3])->active) {
    text = gtk_entry_get_text(GTK_ENTRY(auswertungsfenster->entry));
    erg = strtol(text, NULL, 10);
    erg = MAX(0, erg);
  }

  if (GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[4])->active)
    erg = G_MAXINT;//-1;

  kiel_debug_out(10,"aktuelle_Anzahl_Auswertungsschritte");
  return(erg);
}


void auswertungsfenster_button_press_callback(GtkWidget *widget,gpointer *data)
{
  gint buttonnr;

  kiel_debug_in(10,"auswertungsfenster_button_press_callback");
 
  if (warnungs_fenster_geoeffnet()) beep();
  else {
    buttonnr=GPOINTER_TO_INT(data);

    switch (buttonnr){
    case(BUTTON_AUSWERTUNG_ABBRUCH): 
      auswertungs_abbruch_auf_true();
      printf("auswertungsfenster_button_press\n");
      break;
    default:
      puts("exit in switch ::auswertungsfenster_button_press_callback");
      gtk_exit(1);
    } //switch
  }

  kiel_debug_out(10,"auswertungsfenster_button_press_callback");
}


void auswertungsfenster_entry_changed_callback(GtkWidget *widget)
{
  gchar *text;
  gint anz;
  gchar *neues_label;

  kiel_debug_in(10,"auswertungsfenster_entry_changed_callback");
 
  if (warnungs_fenster_geoeffnet()) beep();
  else {
    text=gtk_entry_get_text(GTK_ENTRY(auswertungsfenster->entry));

    anz=strtol(text,NULL,10);
    anz=MAX(0,anz);
    neues_label=g_strdup_printf("%d %s",anz,BUTTON_VAR_SCHRITTE_TEXT);
    gtk_label_set(GTK_LABEL(GTK_BIN(auswertungsfenster->button_schritte[3])
                            ->child),
                  neues_label);
    g_free(neues_label);
  }

  kiel_debug_out(10,"auswertungsfenster_entry_changed_callback");
}


void auswertungsfenster_entry_enter_callback(GtkWidget *widget)
{
  kiel_debug_in(10,"auswertungsfenster_entry_enter_callback");

  if (warnungs_fenster_geoeffnet()) beep();
  else {
    gtk_toggle_button_set_state(
                 GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[3]),1);
  }

  kiel_debug_out(10,"auswertungsfenster_entry_enter_callback");
}


void auswertungsfenster_radio_button_press_callback(GtkWidget *widget)
{
  gint i;

  kiel_debug_in(10,"auswertungsfenster_radio_button_press_callback");

  if (warnungs_fenster_geoeffnet()) {
    beep();
 
    for(i=0;i<3;i++)
      GTK_TOGGLE_BUTTON(auswertungsfenster->button_auswertungsart[i])->active=
        i==radio_auswahl_bei_warnung_ausw_art;

    for(i=0;i<5;i++)
      GTK_TOGGLE_BUTTON(auswertungsfenster->button_schritte[i])->active=
        i==radio_auswahl_bei_warnung_schritte;

  }

  kiel_debug_out(10,"auswertungsfenster_radio_button_press_callback");
}


void erzeuge_Auswertungs_Fenster(AUSWERTUNGSFENSTER_TYP awf)
{
  GtkWidget *vbox;

  kiel_debug_in(10,"erzeuge_Auswertungsfenster");

  /* Fenster erzeugen, Position setzen */
  awf->fenster=gtk_window_new(GTK_WINDOW_TOPLEVEL); 
  gtk_window_set_title(GTK_WINDOW(awf->fenster),
                       WINDOW_AUSWERTUNGSFENSTER_TEXT);
  gtk_widget_set_uposition(awf->fenster,POSITION_AUSWERTUNGSFENSTER_X,
                                        POSITION_AUSWERTUNGSFENSTER_Y);
  gtk_window_set_policy(GTK_WINDOW(awf->fenster),FALSE,FALSE,FALSE);
  gtk_signal_connect(GTK_OBJECT(awf->fenster),"delete_event",
                     GTK_SIGNAL_FUNC(Auswertungsfenster_Toggle_Button_aus),
                     NULL);
  gtk_container_border_width(GTK_CONTAINER(awf->fenster),5);

  /* Neue VBox */
  vbox=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox),5);
  gtk_container_add(GTK_CONTAINER(awf->fenster),vbox);
  gtk_widget_show(vbox); 
  
  {
    GtkWidget *frame;
    GtkWidget *vbox_frame;
  
    /* Frame fr Auswertungsart-Buttons erzeugen */
    frame=gtk_frame_new(FRAME_AUSWERTUNGSART_TEXT); 
    gtk_box_pack_start(GTK_BOX(vbox),frame,FALSE,FALSE,0);
    gtk_widget_show(frame); 
    /* VBox in den Frame */
    vbox_frame=gtk_vbox_new(FALSE,5);
    gtk_container_border_width(GTK_CONTAINER(vbox_frame),5);
    gtk_container_add(GTK_CONTAINER(frame),vbox_frame);
    gtk_widget_show(vbox_frame); 

    {  
      GSList *gruppe;
       
      /* LI-Radio-Button in Vbox_Frame */
      gruppe=NULL;
      awf->button_auswertungsart[0]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_LI_TEXT);
      gtk_toggle_button_set_state(
                              GTK_TOGGLE_BUTTON(awf->button_auswertungsart[0]),
                                  BUTTON_LI_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_auswertungsart[0]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_auswertungsart[0],
                         FALSE,FALSE,0);
      gtk_widget_show(awf->button_auswertungsart[0]);  
      /* LO-Radio-Button in Vbox_Frame */
      gruppe=
        gtk_radio_button_group(GTK_RADIO_BUTTON(
                               awf->button_auswertungsart[0]));
      awf->button_auswertungsart[1]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_LO_TEXT);
      gtk_toggle_button_set_state(
                              GTK_TOGGLE_BUTTON(awf->button_auswertungsart[1]),
                                  BUTTON_LO_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_auswertungsart[1]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_auswertungsart[1],
                         FALSE,FALSE,0);
      gtk_widget_show(awf->button_auswertungsart[1]);  
      /* FULL-Radio-Button in Vbox_Frame */
      gruppe=
        gtk_radio_button_group(GTK_RADIO_BUTTON(
                               awf->button_auswertungsart[1]));
      awf->button_auswertungsart[2]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_FULL_TEXT);
      gtk_toggle_button_set_state(
                              GTK_TOGGLE_BUTTON(awf->button_auswertungsart[2]),
                                  BUTTON_FULL_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_auswertungsart[2]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_auswertungsart[2],
                         FALSE,FALSE,0);
      if ( global_opt_full_eval  ) {
      gtk_widget_show(awf->button_auswertungsart[2]); 
      }
    }
  }

  {
    GtkWidget *frame;
    GtkWidget *vbox_frame;
  
    /* Frame fr Schrittanzahl-Buttons erzeugen */
    frame=gtk_frame_new(FRAME_SCHRITTANZAHL_TEXT); 
    gtk_box_pack_start(GTK_BOX(vbox),frame,FALSE,FALSE,0);
    gtk_widget_show(frame); 
    /* VBox in den Frame */
    vbox_frame=gtk_vbox_new(FALSE,5);
    gtk_container_border_width(GTK_CONTAINER(vbox_frame),5);
    gtk_container_add(GTK_CONTAINER(frame),vbox_frame);
    gtk_widget_show(vbox_frame); 

    {  
      GSList *gruppe;

      /* 1-Schritt-Radio-Button in Vbox_Frame */
      gruppe=NULL;
      awf->button_schritte[0]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_1_SCHRITT_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(awf->button_schritte[0]),
                                  BUTTON_1_SCHRITT_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_schritte[0]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_schritte[0],
                         FALSE,FALSE,0);
      gtk_widget_show(awf->button_schritte[0]);
      /* 5-Schritte-Radio-Button in Vbox_Frame */
      gruppe=gtk_radio_button_group(GTK_RADIO_BUTTON(awf->button_schritte[0]));
      awf->button_schritte[1]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_5_SCHRITTE_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(awf->button_schritte[1]),
                                  BUTTON_5_SCHRITTE_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_schritte[1]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_schritte[1],
                         FALSE,FALSE,0);
      gtk_widget_show(awf->button_schritte[1]);
      /* 10-Schritte-Radio-Button in Vbox_Frame */
      gruppe=gtk_radio_button_group(GTK_RADIO_BUTTON(awf->button_schritte[1]));
      awf->button_schritte[2]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_10_SCHRITTE_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(awf->button_schritte[2]),
                                  BUTTON_10_SCHRITTE_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_schritte[2]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_schritte[2],
                         FALSE,FALSE,0);
      gtk_widget_show(awf->button_schritte[2]);
 
      {
         GtkWidget *hbox;

        /* HBox in den Vbox_Frame */
        hbox=gtk_hbox_new(FALSE,0);
        gtk_container_border_width(GTK_CONTAINER(hbox),0);
        gtk_container_add(GTK_CONTAINER(vbox_frame),hbox);
        gtk_widget_show(hbox); 

        /* var-Schritte-Radio-Button in Hbox */
        gruppe=
          gtk_radio_button_group(GTK_RADIO_BUTTON(awf->button_schritte[2]));
        awf->button_schritte[3]=
          gtk_radio_button_new_with_label(gruppe,BUTTON_VAR_SCHRITTE_TEXT);
        { 
          gchar *s;

          s=g_strdup_printf("X9999 %s",BUTTON_VAR_SCHRITTE_TEXT);
          gtk_widget_set_usize(awf->button_schritte[3],
                   gdk_string_width(awf->button_schritte[3]->style->font,s)+17,
                               24);
          g_free(s);
        }
        gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(awf->button_schritte[3]),
                                    BUTTON_VAR_SCHRITTE_STATUS);
        gtk_signal_connect(GTK_OBJECT(awf->button_schritte[3]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                           NULL);
        gtk_box_pack_start(GTK_BOX(hbox),awf->button_schritte[3],
                           TRUE,TRUE,0);
        gtk_widget_show(awf->button_schritte[3]);
        /* Entry variable Schritte in Hbox erzeugen */
        awf->entry=gtk_entry_new_with_max_length(4);
        gtk_widget_set_usize(awf->entry,36,20);
        gtk_signal_connect(GTK_OBJECT(awf->entry),"changed",
                    GTK_SIGNAL_FUNC(auswertungsfenster_entry_changed_callback),
                           NULL);
        gtk_signal_connect(GTK_OBJECT(awf->entry),"activate",
                      GTK_SIGNAL_FUNC(auswertungsfenster_entry_enter_callback),
                           NULL);
        gtk_entry_set_text(GTK_ENTRY(awf->entry),"");
        gtk_box_pack_start(GTK_BOX(hbox),awf->entry,FALSE,FALSE,5);
        gtk_widget_show(awf->entry);
      }

      /* bis-fertig-Radio-Button in Vbox_Frame */
      gruppe=
        gtk_radio_button_group(GTK_RADIO_BUTTON(awf->button_schritte[3]));
      awf->button_schritte[4]=
        gtk_radio_button_new_with_label(gruppe,BUTTON_BIS_FERTIG_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(awf->button_schritte[4]),
                                  BUTTON_BIS_FERTIG_STATUS);
      gtk_signal_connect(GTK_OBJECT(awf->button_schritte[4]),"clicked",
              GTK_SIGNAL_FUNC(auswertungsfenster_radio_button_press_callback),
                         NULL);
      gtk_box_pack_start(GTK_BOX(vbox_frame),awf->button_schritte[4],
                         FALSE,FALSE,0);
      gtk_widget_show(awf->button_schritte[4]);
    }
  }  

  {
    GtkWidget *button;

    /* Abbruch-Button in VBox */
    button=gtk_button_new_with_label(BUTTON_AUSWERTUNG_ABBRUCH_TEXT);
    gtk_signal_connect(GTK_OBJECT(button),"clicked",
                     GTK_SIGNAL_FUNC(auswertungsfenster_button_press_callback),
                       GINT_TO_POINTER(BUTTON_AUSWERTUNG_ABBRUCH));
    gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,0);
    gtk_widget_show(button);  
  }

  /* ggf. anzeigen */
  if (BUTTON_AUSWERTUNGS_FENSTER_STATUS) gtk_widget_show(awf->fenster);

  kiel_debug_out(10,"erzeuge_Auswertungsfenster");
}
