/* Befehls Fenster */
#include "kiel_global.h"

#include "kiel_gtk_bf.h"
#include "kiel_gtk_bf_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk_df.h"
#include "kiel_gtk_uef.h"
#include "kiel_gtk_wf.h"
#include "kiel_gtk.h"
#include "../Misc/callgraph.h"

#include "kiel_fkt.h"

#include "kiel_ressource.h"


static void zeichne_Mausbelegung(PIXMAP_DRAWINGAREA_DATEN_TYP,gint);



gboolean befehlsfenster_timeout(gpointer data)
{
  static gint zeit=0;
  gint stunden,minuten,sekunden;
  gchar *stunden_text,*minuten_text,*sekunden_text;
  gchar *s;
  
  /* Schon wieder ist eine Sekunde vergangen */
  zeit++;
 
  stunden=zeit/3600;
  minuten=(zeit%3600)/60;
  sekunden=zeit%60;

  stunden_text=g_strdup_printf("%2d h",stunden);
  minuten_text=g_strdup_printf("%2d min",minuten);
  sekunden_text=g_strdup_printf("%2d sec",sekunden);

  if (stunden>0)
    s=g_strdup_printf("%s - %s %s %s",WINDOW_BEFHELSFENSTER_TEXT,stunden_text,
                                      minuten_text,sekunden_text);
  else if (minuten>0)
    s=g_strdup_printf("%s - %s %s",WINDOW_BEFHELSFENSTER_TEXT,minuten_text,
                                   sekunden_text);
  else
   s=g_strdup_printf("%s - %s",WINDOW_BEFHELSFENSTER_TEXT,sekunden_text);
  
  g_free(sekunden_text);
  g_free(minuten_text);
  g_free(stunden_text);

  gtk_window_set_title(GTK_WINDOW(data),s);
  g_free(s);

  return(TRUE);
} 


void befehlsfenster_button_press_callback(GtkWidget *widget,gpointer *data)
{
  gint buttonnr;
  BAUMFENSTER_TYP *bmfensterP;
  ZEICHENREIHENFENSTER_TYP *zrfensterP;
  AUSDRUCKEINGABEFENSTER_TYP *aefensterP;
  UEBERSICHTSFENSTER_TYP *adkuefensterP;
  UEBERSICHTSFENSTER_TYP *rvuefensterP;
  UNDOREDOFENSTER_TYP *urfensterP;
  AUSWERTUNGSFENSTER_TYP *awfensterP; 

  kiel_debug_in(10,"befehlsfenster_button_press_callback");

  buttonnr=GPOINTER_TO_INT(data);
 
  if ((warnungs_fenster_geoeffnet())&&(!trotz_warnung())) {
    beep();
    switch (buttonnr){
      case(BUTTON_MLAUSDRUCK_UEBERSICHT):
      case(BUTTON_RV_UEBERSICHT)        : 
      case(BUTTON_AUSDRUCKBAUM_FENSTER) :
      case(BUTTON_ZEICHENREIHEN_FENSTER):
      case(BUTTON_UNDOREDO_FENSTER)     :
      case(BUTTON_AUSWERTUNGS_FENSTER)  :
        GTK_TOGGLE_BUTTON(widget)->active = !GTK_TOGGLE_BUTTON(widget)->active;
        break; 
     default:;
    } //switch
  } else {
    bmfensterP   = hole_adresse_von_baumfenster(); 
    zrfensterP   = hole_adresse_von_zeichenreihenfenster();
    aefensterP   = hole_adresse_von_ausdruckeingabefenster();
    adkuefensterP= hole_adresse_von_adkuebersichtsfenster();
    rvuefensterP = hole_adresse_von_rvuebersichtsfenster();
    urfensterP   = hole_adresse_von_undoredofenster();
    awfensterP   = hole_adresse_von_auswertungsfenster();

    switch (buttonnr){
      case(BUTTON_MLAUSDRUCK_LADEN):
        Ausdruck_Dateiauswahl_oeffnen();
        break;
      case(BUTTON_MLAUSDRUCK_EINGEBEN):
        gtk_widget_hide((*aefensterP)->fenster);
        gtk_widget_grab_focus((*aefensterP)->entry);
        gtk_widget_show((*aefensterP)->fenster);
        break;
      case(BUTTON_MLAUSDRUCK_UEBERSICHT):
        if (GTK_TOGGLE_BUTTON(widget)->active)
          gtk_widget_show((*adkuefensterP)->fenster);
        else gtk_widget_hide((*adkuefensterP)->fenster);
        break;
      case(BUTTON_MLPROGRAMM_LADEN):
        Programm_Dateiauswahl_oeffnen();
        break;
      case(BUTTON_CALLGRAPH):
	show_callgraph();
	break;
      case(BUTTON_RV_UEBERSICHT): 
        if (GTK_TOGGLE_BUTTON(widget)->active)
          gtk_widget_show((*rvuefensterP)->fenster);
        else gtk_widget_hide((*rvuefensterP)->fenster);
        break;
      case(BUTTON_AUSDRUCKBAUM_FENSTER): 
        if (GTK_TOGGLE_BUTTON(befehlsfenster->button_ausdruckbaum)->active)
          gtk_widget_show((*bmfensterP)->fenster);
        else gtk_widget_hide((*bmfensterP)->fenster);
        break;
      case(BUTTON_ZEICHENREIHEN_FENSTER):
        if (GTK_TOGGLE_BUTTON(befehlsfenster->button_zeichenreihe)->active)
          gtk_widget_show((*zrfensterP)->fenster);
        else gtk_widget_hide((*zrfensterP)->fenster);
        break;
      case(BUTTON_UNDOREDO_FENSTER):
        if (GTK_TOGGLE_BUTTON(widget)->active)
          gtk_widget_show((*urfensterP)->fenster);
        else gtk_widget_hide((*urfensterP)->fenster);
        break; 
      case(BUTTON_AUSWERTUNGS_FENSTER):
        if (GTK_TOGGLE_BUTTON(widget)->active)
          gtk_widget_show((*awfensterP)->fenster);
        else gtk_widget_hide((*awfensterP)->fenster);
        break; 
      default:puts("exit in switch ::befehlsfenster_button_press_callback");
              gtk_exit(1);
    }
  }

  kiel_debug_out(10,"befehlsfenster_button_press_callback");
}


void mausbelegung_configure_event(GtkWidget *widget,GdkEventConfigure *event,
                                  gpointer *data)
{
  GdkRectangle update_rect; 
  gint nr;
  PIXMAP_DRAWINGAREA_DATEN_TYP pixdraw;

  kiel_debug_in(10,"mausbelegung_configure_event");

  nr=GPOINTER_TO_INT(data);
  pixdraw=befehlsfenster->pixdraw[nr];

  if (pixdraw->pixm) gdk_pixmap_unref(pixdraw->pixm);

  pixdraw->pixm=gdk_pixmap_new(widget->window,widget->allocation.width,
                                 widget->allocation.height,-1);

  gdk_draw_rectangle(pixdraw->pixm,widget->style->white_gc,TRUE,
                     0,0,widget->allocation.width,widget->allocation.height);

  zeichne_Mausbelegung(pixdraw,nr);

  update_rect.x=0;
  update_rect.y=0;
  update_rect.width=pixdraw->draw_a->allocation.width;
  update_rect.height=pixdraw->draw_a->allocation.height;

  gtk_widget_draw(pixdraw->draw_a,&update_rect);

  kiel_debug_out(10,"mausbelegung_configure_event");
}


void mausbelegung_expose_event(GtkWidget *widget,GdkEventExpose *event,
                               PIXMAP_DRAWINGAREA_DATEN_TYP eventdata)
{
  kiel_debug_in(6,"mausbelegung_expose_event");

  gdk_draw_pixmap(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
                  eventdata->pixm,
                  event->area.x,event->area.y,
                  event->area.x,event->area.y,
                  event->area.width,event->area.height);

  kiel_debug_out(6,"mausbelegung_expose_event");
}


void erzeuge_Befehls_Fenster(BEFEHLSFENSTER_TYP bf)
{
  GtkWidget *hbox;

  kiel_debug_in(10,"erzeuge_Befehls_Fenster");

  /* Fenster erzeugen, Position setzen */
  bf->fenster=gtk_window_new(GTK_WINDOW_TOPLEVEL); 
  gtk_widget_set_name(bf->fenster,"Befehlsfenster");
  gtk_window_set_title(GTK_WINDOW(bf->fenster),WINDOW_BEFHELSFENSTER_TEXT);
  gtk_widget_set_uposition(bf->fenster,POSITION_BEFEHLSFENSTER_X,
                                       POSITION_BEFEHLSFENSTER_Y);
  gtk_window_set_policy(GTK_WINDOW(bf->fenster),FALSE,FALSE,FALSE);
  gtk_signal_connect(GTK_OBJECT(bf->fenster),"delete_event",
                     GTK_SIGNAL_FUNC(programm_verlassen_event),NULL);
  gtk_container_border_width(GTK_CONTAINER(bf->fenster),5);

  /* Timer erzeugen */
  bf->timer_id=gtk_timeout_add(1000,befehlsfenster_timeout,
                               (gpointer)befehlsfenster->fenster);

  /* Neuer HBox */
  hbox=gtk_hbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(hbox),5);
  gtk_container_add(GTK_CONTAINER(bf->fenster),hbox);
  gtk_widget_show(hbox); 
  
  {
    GtkWidget *frame;
    GtkWidget *vbox;
  
    /* Frame fr Ausdruck-Buttons erzeugen */
    frame=gtk_frame_new(FRAME_AUSDRUCK_TEXT); 
    gtk_box_pack_start(GTK_BOX(hbox),frame,FALSE,FALSE,0);
    gtk_widget_show(frame); 
    /* VBox in den Frame */
    vbox=gtk_vbox_new(FALSE,5);
    gtk_container_border_width(GTK_CONTAINER(vbox),5);
    gtk_container_add(GTK_CONTAINER(frame),vbox);
    gtk_widget_show(vbox);

    {
      GtkWidget *button;

      /* ML-Ausdruck-Laden-Button in VBox */
      button=gtk_button_new_with_label(BUTTON_MLAUSDRUCK_LADEN_TEXT);
      gtk_signal_connect(GTK_OBJECT(button),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_MLAUSDRUCK_LADEN));
      gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,0);
      gtk_widget_show(button); 
      /* ML-Ausdruck-Eingeben-Button in VBox */
      button=gtk_button_new_with_label(BUTTON_MLAUSDRUCK_EINGEBEN_TEXT);
      gtk_signal_connect(GTK_OBJECT(button),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_MLAUSDRUCK_EINGEBEN));
      gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,0);
      gtk_widget_show(button); 
      /* ML-Ausdruck-bersicht-Toggle-Button in VBox */
      bf->button_adkuebersicht=
        gtk_toggle_button_new_with_label(BUTTON_MLAUSDRUCK_UEBERSICHT_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(bf->button_adkuebersicht),
                                  BUTTON_MLAUSDRUCK_UEBERSICHT_STATUS);
      gtk_signal_connect(GTK_OBJECT(bf->button_adkuebersicht),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_MLAUSDRUCK_UEBERSICHT));
      gtk_box_pack_end(GTK_BOX(vbox),bf->button_adkuebersicht,FALSE,FALSE,0);
      gtk_widget_show(bf->button_adkuebersicht);                     
    }
  }

  {
    GtkWidget *frame;
    GtkWidget *vbox;
  
    /* Frame fr Rechenvorschrift-Buttons erzeugen */
    frame=gtk_frame_new(FRAME_RECHENVORSCHRIFT_TEXT); 
    gtk_box_pack_start(GTK_BOX(hbox),frame,FALSE,FALSE,0);
    gtk_widget_show(frame); 
    /* VBox in den Frame */
    vbox=gtk_vbox_new(FALSE,5);
    gtk_container_border_width(GTK_CONTAINER(vbox),5);
    gtk_container_add(GTK_CONTAINER(frame),vbox);
    gtk_widget_show(vbox);

    {
      GtkWidget *button;

      /* ML-Programm-Laden-Button in VBox */
      button=gtk_button_new_with_label(BUTTON_MLPROGRAMM_LADEN_TEXT);
      gtk_signal_connect(GTK_OBJECT(button),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_MLPROGRAMM_LADEN));
      gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,0);
      gtk_widget_show(button); 

      /* ML-Programm-Call-Graph in VBox */
      button=gtk_button_new_with_label(BUTTON_CALLGRAPH_TEXT);
      gtk_signal_connect(GTK_OBJECT(button),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_CALLGRAPH));
      gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,0);
      gtk_widget_show(button); 

      /* ML-RV-bersicht-Toggle-Button in VBox */
      bf->button_rvuebersicht=
        gtk_toggle_button_new_with_label(BUTTON_RV_UEBERSICHT_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(bf->button_rvuebersicht),
                                  BUTTON_RV_UEBERSICHT_STATUS);
      gtk_signal_connect(GTK_OBJECT(bf->button_rvuebersicht),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_RV_UEBERSICHT));
      gtk_box_pack_end(GTK_BOX(vbox),bf->button_rvuebersicht,FALSE,FALSE,0);
      gtk_widget_show(bf->button_rvuebersicht);                     
    }
  }

  {
    GtkWidget *frame;
    GtkWidget *vbox;
  
    /* Frame fr Fenster-Buttons erzeugen */
    frame=gtk_frame_new(FRAME_FENSTER_TEXT); 
    gtk_box_pack_start(GTK_BOX(hbox),frame,FALSE,FALSE,0);
    gtk_widget_show(frame); 
    /* VBox in den Frame */
    vbox=gtk_vbox_new(FALSE,5);
    gtk_container_border_width(GTK_CONTAINER(vbox),5);
    gtk_container_add(GTK_CONTAINER(frame),vbox);
    gtk_widget_show(vbox);

    {
      /* Ausdruckbaum-Fenster-Toggle-Button in VBox */
      bf->button_ausdruckbaum=
        gtk_toggle_button_new_with_label(BUTTON_AUSDRUCKBAUM_FENSTER_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(bf->button_ausdruckbaum),
                                  BUTTON_AUSDRUCKBAUM_FENSTER_STATUS);
      gtk_signal_connect(GTK_OBJECT(bf->button_ausdruckbaum),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_AUSDRUCKBAUM_FENSTER));
      gtk_box_pack_start(GTK_BOX(vbox),bf->button_ausdruckbaum,FALSE,FALSE,0);
      gtk_widget_show(bf->button_ausdruckbaum);  
      /* Zeichenreihen-Fenster-Toggle-Button in VBox */
      bf->button_zeichenreihe=
        gtk_toggle_button_new_with_label(BUTTON_ZEICHENREIHEN_FENSTER_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(bf->button_zeichenreihe),
                                  BUTTON_ZEICHENREIHEN_FENSTER_STATUS);
      gtk_signal_connect(GTK_OBJECT(bf->button_zeichenreihe),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_ZEICHENREIHEN_FENSTER));
      gtk_box_pack_start(GTK_BOX(vbox),bf->button_zeichenreihe,FALSE,FALSE,0);
      gtk_widget_show(bf->button_zeichenreihe);
      /* Undo-Redo-Fenster-Toggle-Button in VBox */
      bf->button_undoredo=
        gtk_toggle_button_new_with_label(BUTTON_UNDOREDO_FENSTER_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(bf->button_undoredo),
                                  BUTTON_UNDOREDO_FENSTER_STATUS);
      gtk_signal_connect(GTK_OBJECT(bf->button_undoredo),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_UNDOREDO_FENSTER));
      gtk_box_pack_start(GTK_BOX(vbox),bf->button_undoredo,FALSE,FALSE,0);
      gtk_widget_show(bf->button_undoredo);
      /* Auswertungs-Toggle-Button in VBox */
      bf->button_auswertung=
        gtk_toggle_button_new_with_label(BUTTON_AUSWERTUNGS_FENSTER_TEXT);
      gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(bf->button_auswertung),
                                  BUTTON_AUSWERTUNGS_FENSTER_STATUS);
      gtk_signal_connect(GTK_OBJECT(bf->button_auswertung),"clicked",
                         GTK_SIGNAL_FUNC(befehlsfenster_button_press_callback),
                         GINT_TO_POINTER(BUTTON_AUSWERTUNGS_FENSTER));
      gtk_box_pack_start(GTK_BOX(vbox),bf->button_auswertung,FALSE,FALSE,0);
      gtk_widget_show(bf->button_auswertung);
    }
  }

  {
    GtkWidget *frame;
    GtkWidget *table;
    GtkWidget *hbox0;
    gint i;
    GtkWidget *vbox;
    GtkWidget *label;
    GtkWidget *separator;
  
    /* Frame fr Maustastenbelegung erzeugen */
    frame=gtk_frame_new(FRAME_MAUSTASTEBELEGUNG_TEXT);  
    gtk_box_pack_start(GTK_BOX(hbox),frame,FALSE,FALSE,0);
    gtk_widget_show(frame); 

    /* HBox0 in Frame */ 
    hbox0=gtk_hbox_new(FALSE,0);
    gtk_container_border_width(GTK_CONTAINER(hbox0),5);
    gtk_container_add(GTK_CONTAINER(frame),hbox0);
    gtk_widget_show(hbox0);
   
    /* Table in HBox0 */
    table=gtk_table_new(5,3,FALSE);
    gtk_container_border_width(GTK_CONTAINER(table),0);
    gtk_box_pack_start(GTK_BOX(hbox0),table,TRUE,FALSE,0);
    gtk_widget_show(table);
    gtk_table_set_row_spacings(GTK_TABLE(table),1);
    gtk_table_set_col_spacings(GTK_TABLE(table),0);

    #define VBOX_ATTACHES(nr) 0,1,nr*2,nr*2+1

    for(i=0;i<3;i++){
      /* VBoxes in das Table */
      vbox=gtk_vbox_new(FALSE,0);
      gtk_table_attach(GTK_TABLE(table),vbox,VBOX_ATTACHES(i),
                                       GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                        5,0);
      gtk_widget_show(vbox);
      /* Drawing Areas in VBoxes */
      bf->pixdraw[i]=(PIXMAP_DRAWINGAREA_DATEN_TYP)
                     mtmalloc(sizeof(PIXMAP_DRAWINGAREA_DATEN_STRUCT));
      bf->pixdraw[i]->draw_a=gtk_drawing_area_new();
      gtk_box_pack_start(GTK_BOX(vbox),bf->pixdraw[i]->draw_a,TRUE,FALSE,0);
      gtk_drawing_area_size(GTK_DRAWING_AREA(bf->pixdraw[i]->draw_a),50,30);
      gtk_widget_show(bf->pixdraw[i]->draw_a);
      gtk_signal_connect(GTK_OBJECT(bf->pixdraw[i]->draw_a),"expose_event",
                         GTK_SIGNAL_FUNC(mausbelegung_expose_event),
                         bf->pixdraw[i]);
      gtk_signal_connect(GTK_OBJECT(bf->pixdraw[i]->draw_a),"configure_event",
                         GTK_SIGNAL_FUNC(mausbelegung_configure_event),
                         GINT_TO_POINTER(i));
      gtk_widget_set_events(bf->pixdraw[i]->draw_a,GDK_EXPOSURE_MASK|
                                                   GDK_LEAVE_NOTIFY_MASK);
    }
    /* Labels in das Table */
    label=gtk_label_new(LABEL_MAUSTASTEN_AUSWERTEN); 
    gtk_table_attach(GTK_TABLE(table),label,1,2,0,1,
                                      GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                      5,0);
    gtk_widget_show(label);
    label=gtk_label_new(LABEL_MAUSTASTEN_EXPANDIEREN); 
    gtk_table_attach(GTK_TABLE(table),label,1,2,2,3,
                                      GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                      5,0);
    gtk_widget_show(label);
    label=gtk_label_new(LABEL_MAUSTASTEN_VEREINFACHEN); 
    gtk_table_attach(GTK_TABLE(table),label,1,2,4,5,
                                      GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                      5,0);
    gtk_widget_show(label);
    /* 2 Seperatoren in Table */
    separator=gtk_hseparator_new();
    gtk_table_attach_defaults(GTK_TABLE(table),separator,0,3,1,2);
    gtk_widget_show(separator);
    separator=gtk_hseparator_new();
    gtk_table_attach_defaults(GTK_TABLE(table),separator,0,3,3,4);
    gtk_widget_show(separator); 

    /* Seperator in HBox0*/
    separator=gtk_vseparator_new();
    gtk_box_pack_start(GTK_BOX(hbox0),separator,TRUE,FALSE,0);
    gtk_widget_show(separator);

    /* Table in HBox0 */
    table=gtk_table_new(3,3,FALSE);
    gtk_container_border_width(GTK_CONTAINER(table),0);
    gtk_box_pack_start(GTK_BOX(hbox0),table,TRUE,FALSE,0);
    gtk_widget_show(table);
    gtk_table_set_row_spacings(GTK_TABLE(table),1);
    gtk_table_set_col_spacings(GTK_TABLE(table),0);

    #define VBOX_ATTACHES2(nr) 0,1,(nr-3)*2,(nr-3)*2+1

    for(i=3;i<5;i++){
      /* VBoxes in das Table */
      vbox=gtk_vbox_new(FALSE,0);
      gtk_table_attach(GTK_TABLE(table),vbox,VBOX_ATTACHES2(i),
                                       GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                        5,0);
      gtk_widget_show(vbox);
      /* Drawing Areas in VBoxes */
      bf->pixdraw[i]=(PIXMAP_DRAWINGAREA_DATEN_TYP)
                     mtmalloc(sizeof(PIXMAP_DRAWINGAREA_DATEN_STRUCT));
      bf->pixdraw[i]->draw_a=gtk_drawing_area_new();
      gtk_box_pack_start(GTK_BOX(vbox),bf->pixdraw[i]->draw_a,TRUE,FALSE,0);
      gtk_drawing_area_size(GTK_DRAWING_AREA(bf->pixdraw[i]->draw_a),50,30);
      gtk_widget_show(bf->pixdraw[i]->draw_a);
      gtk_signal_connect(GTK_OBJECT(bf->pixdraw[i]->draw_a),"expose_event",
                         GTK_SIGNAL_FUNC(mausbelegung_expose_event),
                         bf->pixdraw[i]);
      gtk_signal_connect(GTK_OBJECT(bf->pixdraw[i]->draw_a),"configure_event",
                         GTK_SIGNAL_FUNC(mausbelegung_configure_event),
                         GINT_TO_POINTER(i));
      gtk_widget_set_events(bf->pixdraw[i]->draw_a,GDK_EXPOSURE_MASK|
                                                   GDK_LEAVE_NOTIFY_MASK);
    }
    /* Labels in das Table */
    label=gtk_label_new(LABEL_MAUSTASTEN_NACHKOMMASTELLIGKEIT); 
    gtk_table_attach(GTK_TABLE(table),label,1,2,0,1,
                                      GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                      5,0);
    gtk_widget_show(label);
    label=gtk_label_new(LABEL_MAUSTASTEN_BASISOPERATIONEN); 
    gtk_table_attach(GTK_TABLE(table),label,1,2,2,3,
                                      GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,
                                      5,0);
    gtk_widget_show(label);
    /* Seperator in Table */
    separator=gtk_hseparator_new();
    gtk_table_attach_defaults(GTK_TABLE(table),separator,0,3,1,2);
    gtk_widget_show(separator);

#ifdef gobi
    /* Table in Frame */
    table=gtk_table_new(5,5,FALSE);
    gtk_container_border_width(GTK_CONTAINER(table),5);
    gtk_container_add(GTK_CONTAINER(frame),table);
    gtk_widget_show(table);
    gtk_table_set_row_spacings(GTK_TABLE(table),0);
    gtk_table_set_col_spacings(GTK_TABLE(table),5);

    #define VBOX_ATTACHES(nr) (nr%2==0)?0:3,(nr%2==0)?1:4,(nr/2)*2,(nr/2)*2+1

    for(i=0;i<4;i++){
      /* VBoxes in das Table */
      vbox=gtk_vbox_new(FALSE,0);
      gtk_table_attach_defaults(GTK_TABLE(table),vbox,VBOX_ATTACHES(i));
      gtk_widget_show(vbox);
      /* Drawing Areas in VBoxes */
      bf->pixdraw[i]=(PIXMAP_DRAWINGAREA_DATEN_TYP)
                     mtmalloc(sizeof(PIXMAP_DRAWINGAREA_DATEN_STRUCT));
      bf->pixdraw[i]->draw_a=gtk_drawing_area_new();
      gtk_box_pack_start(GTK_BOX(vbox),bf->pixdraw[i]->draw_a,TRUE,FALSE,0);
      gtk_drawing_area_size(GTK_DRAWING_AREA(bf->pixdraw[i]->draw_a),50,30);
      gtk_widget_show(bf->pixdraw[i]->draw_a);
      gtk_signal_connect(GTK_OBJECT(bf->pixdraw[i]->draw_a),"expose_event",
                         GTK_SIGNAL_FUNC(mausbelegung_expose_event),
                         bf->pixdraw[i]);
      gtk_signal_connect(GTK_OBJECT(bf->pixdraw[i]->draw_a),"configure_event",
                         GTK_SIGNAL_FUNC(mausbelegung_configure_event),
                         GINT_TO_POINTER(i));
      gtk_widget_set_events(bf->pixdraw[i]->draw_a,GDK_EXPOSURE_MASK|
                                                   GDK_LEAVE_NOTIFY_MASK);
    }
    /* Labels in das Table */
    label=gtk_label_new(LABEL_MAUSTASTEN_AUSWERTEN); 
    gtk_table_attach_defaults(GTK_TABLE(table),label,1,2,0,1);
    gtk_widget_show(label);
    label=gtk_label_new(LABEL_MAUSTASTEN_EXPANDIEREN); 
    gtk_table_attach_defaults(GTK_TABLE(table),label,4,5,0,1);
    gtk_widget_show(label);
    label=gtk_label_new(LABEL_MAUSTASTEN_VEREINFACHEN); 
    gtk_table_attach_defaults(GTK_TABLE(table),label,1,2,2,3);
    gtk_widget_show(label);
    label=gtk_label_new(LABEL_MAUSTASTEN_NACHKOMMASTELLIGKEIT); 
    gtk_table_attach_defaults(GTK_TABLE(table),label,4,5,2,3);
    gtk_widget_show(label);
    /* 2 Seperatoren */
    separator=gtk_hseparator_new();
    gtk_table_attach_defaults(GTK_TABLE(table),separator,0,5,1,2);
    gtk_widget_show(separator);
    separator=gtk_vseparator_new();
    gtk_table_attach_defaults(GTK_TABLE(table),separator,2,3,0,3);
    gtk_widget_show(separator);
#endif //gobi
  }
//  {
//    GtkWidget *button;
//
//    /* Beenden-Button in HBox */
//    button=gtk_button_new_with_label(BUTTON_BEENDEN_TEXT);
//    gtk_signal_connect(GTK_OBJECT(button),"clicked",
//                       GTK_SIGNAL_FUNC(programm_verlassen_event),
//                       NULL);
//    gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,0);
//    gtk_widget_show(button);  
//  }

  /* und anzeigen */
  gtk_widget_show(bf->fenster);

  {
#include "bilder/KIEL.xpm"

    /* Icon setzen */
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;

    style=gtk_widget_get_style(bf->fenster);

    pixmap=gdk_pixmap_create_from_xpm_d(bf->fenster->window,&mask,
                                        &style->bg[GTK_STATE_NORMAL],
                                        (gchar **)KIEL);

    gdk_window_set_icon(bf->fenster->window,NULL,pixmap,mask); 
  }

  {
#ifdef ENGLISCH
  #include "bilder/KIEL_Qe.xpm"
#else //ENGLISCH
  #include "bilder/KIEL_Qd.xpm"
#endif //ENGLISCH
    GtkWidget *button;

    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;

    style=gtk_widget_get_style(bf->fenster);
    pixmap=gdk_pixmap_create_from_xpm_d(bf->fenster->window,&mask,
                                        &style->bg[GTK_STATE_NORMAL],
                                        (gchar **)KIEL_QUIT);

    /* a pixmap widget to contain the pixmap */
    pixmapwid=gtk_pixmap_new(pixmap,mask);
    gtk_widget_show(pixmapwid);

    /* Quit-Button in HBox */
    button=gtk_button_new();
    gtk_signal_connect(GTK_OBJECT(button),"clicked",
                       GTK_SIGNAL_FUNC(programm_verlassen_event),
                       NULL);
    gtk_container_add(GTK_CONTAINER(button),pixmapwid);
    gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,0);
    gtk_widget_show(button);  
  }

  kiel_debug_out(10,"erzeuge_Befehls_Fenster");
}


/* ---------- Mausbelegung -----------*/
static void 
zeichne_Mausbelegung(PIXMAP_DRAWINGAREA_DATEN_TYP pix_draw,gint nr)
{ 
  kiel_debug_in(9,"zeichne_Mausbelegung");

  if (pix_draw->pixm) {
    /* Schnur */
    gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,FALSE,
                 -8,-1,
                 17,18,
                 0*64,60*64); 
    gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,FALSE,
                 -7,-1,
                 17,18,
                 0*64,60*64); 
    /* Maus*/
    gdk_draw_rectangle(pix_draw->pixm,pix_draw->draw_a->style->black_gc,FALSE,
                       2,8,
                       15,20); 

    /* Maustaste hervorheben und Knoten zeichnen */
    switch(nr){
      case(0):gdk_draw_rectangle(pix_draw->pixm,
                                 pix_draw->draw_a->style->dark_gc[0],TRUE,
                                 2,8,
                                 5,8); 
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,
                           FALSE,
                           25,1,
                           20,12,
                           0*64,360*64);
              gdk_draw_string(pix_draw->pixm,
                              pix_draw->draw_a->style->font,
                              pix_draw->draw_a->style->black_gc,
                              33,10,
                              "+"); 
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->fg_gc[1],
                           TRUE,
                           25,16,
                           20,12,
                           0*64,360*64); 
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,
                           FALSE,
                           25,16,
                           20,12,
                           0*64,360*64);
              gdk_draw_string(pix_draw->pixm,
                              pix_draw->draw_a->style->font,
                              pix_draw->draw_a->style->black_gc,
                              33,25,
                              "F"); 
              break;
      case(1):gdk_draw_rectangle(pix_draw->pixm,
                                 pix_draw->draw_a->style->dark_gc[0],TRUE,
                                 12,8,
                                 5,8); 
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->fg_gc[1],
                           TRUE,
                           25,10,
                           20,12,
                           0*64,360*64); 
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,
                           FALSE,
                           25,10,
                           20,12,
                           0*64,360*64); 
              gdk_draw_string(pix_draw->pixm,
                              pix_draw->draw_a->style->font,
                              pix_draw->draw_a->style->black_gc,
                              33,19,
                              "F");
              break;
      case(2):gdk_draw_rectangle(pix_draw->pixm,
                                 pix_draw->draw_a->style->dark_gc[0],TRUE,
                                 12,8,
                                 5,8);
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,
                           FALSE,
                           25,10,
                           20,12,
                           0*64,360*64);
              gdk_draw_string(pix_draw->pixm,
                              pix_draw->draw_a->style->font,
                              pix_draw->draw_a->style->black_gc,
                              30,19,
                              "if"); 
              break;
      case(3):gdk_draw_rectangle(pix_draw->pixm,
                                 pix_draw->draw_a->style->dark_gc[0],TRUE,
                                 7,8,
                                 5,8);
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->fg_gc[0],
                           TRUE,
                           25,1,
                           20,12,
                           0*64,360*64);
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,
                           FALSE,
                           25,1,
                           20,12,
                           0*64,360*64);
              gdk_draw_string(pix_draw->pixm,
                              pix_draw->draw_a->style->font,
                              pix_draw->draw_a->style->black_gc,
                              28,10,
                              "1.3"); 
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->fg_gc[0],
                           TRUE,
                           25,16,
                           20,12,
                           0*64,360*64);
              gdk_draw_arc(pix_draw->pixm,pix_draw->draw_a->style->black_gc,
                           FALSE,
                           25,16,
                           20,12,
                           0*64,360*64);
              gdk_draw_string(pix_draw->pixm,
                              pix_draw->draw_a->style->font,
                              pix_draw->draw_a->style->black_gc,
                              28,25,
                              "\"S\""); 
              break;
      case(4):gdk_draw_rectangle(pix_draw->pixm,
                                 pix_draw->draw_a->style->dark_gc[0],TRUE,
                                 7,8,
                                 5,8);
              break;

      default:puts("exit in switch ::zeichne_Mausbelegung");
              gtk_exit(1);
    }

    /* linke Taste */
    gdk_draw_rectangle(pix_draw->pixm,pix_draw->draw_a->style->black_gc,FALSE,
                       2,8,
                       5,8); 
    /* mittlere Taste */
    gdk_draw_rectangle(pix_draw->pixm,pix_draw->draw_a->style->black_gc,FALSE,
                       7,8,
                       5,8);
    /* rechte Taste */
    gdk_draw_rectangle(pix_draw->pixm,pix_draw->draw_a->style->black_gc,FALSE,
                       12,8,
                       5,8);
  }

  kiel_debug_out(9,"zeichne_Mausbelegung");
}
