#include "kiel_global.h"

#include "kiel_gtk_bmf.h"
#include "kiel_gtk_bmf_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk_uef.h"
#include "kiel_gtk_awf.h"
#include "kiel_gtk_wf.h"
#include "kiel_gtk.h"

  #include "kiel_fkt.h"

#include "kiel_ressource.h"
#include "../Syntaxtree/syntaxtree.h"
#include "../Typechecker/tc_util.h"
#include "expr_node_misc.h"
#include "drawable_expr.h"
#include "gtk_eval.h"


static Expr_node_ptr zuletzt_bearbeitet_abaum     = NULL;
static Expr_node_ptr expr_node_fuer_geoeffnetes_popup = NULL;
static Drawable_expr_ptr adk_fuer_geoeffnetes_popup = NULL;


void untersuche_mausklick(GdkEventButton *event,gint maustaste,
                          Drawable_expr_ptr pDrawExpr)
{  
  gdouble x,y;
  gboolean neupositionierung_noetig = FALSE;
  Expr_node_ptr clicked_node, parent/*of clicked_node*/;
  Expr_node_misc_ptr pMisc;
 
  kiel_debug_in(10,"untersuche_mausklick");
  
  if ((pDrawExpr != NULL) && pDrawExpr->drawingAllowed) {
    x = event->x + baumfenster->adjustmenth->value;
    y = event->y + baumfenster->adjustmentv->value; 

   //clicked_node = findClickedNode(pDrawExpr->act_expr, x, y, baumfenster);
    findClickedNodeAndParent(pDrawExpr->act_expr, x, y, baumfenster, 
			     &clicked_node, &parent);
    DBUG_EXECUTE ("", 
    {
      if ((clicked_node != NULL) && (isDrawableNode(clicked_node))) {
	printf_expr_node(clicked_node);
      } else {
	clicked_node = NULL;
	printf("no node clicked\n");
      } //if
    }); //DBUG_EXECUTE

    if ((clicked_node != NULL) && (isDrawableNode(clicked_node))) {
      //MLRVsP = hole_adresse_von_MLRechenvorschriften();
      neupositionierung_noetig = FALSE;

      switch(maustaste){
      case(LINKE_MAUSTASTE):
	if (1/*!abaum->ausgewertet*/) {
	  /* Baum soll nicht neu gezeichnet werden, bevor er neu */
	  /* positioniert wurde, also:                           */
	  //pDrawExpr->Zeichnen_erlaubt=FALSE;
	  neupositionierung_noetig = 
	    gtk_eval(pDrawExpr, parent, clicked_node,
		     aktuelle_Auswertungsart(), 
		     aktuelle_Anzahl_Auswertungsschritte(), FALSE, FALSE);
	  zuletzt_bearbeitet_abaum = eval_start_node_after_evaluation;
	  zuletzt_bearbeitet_x = (gint)x;
	  zuletzt_bearbeitet_y = (gint)y;
	}
	break;

      case(RECHTE_MAUSTASTE):
	if ( (clicked_node->nodetype == e_userfun) ||
	     (clicked_node->nodetype == e_ifthenelse) || 
	     (clicked_node->nodetype == e_let)
	   ) {
	  /* Baum soll nicht neu gezeichnet werden, bevor er neu */
	  /* positioniert wurde, also:                           */
	  //pDrawExpr->Zeichnen_erlaubt=FALSE;

	  if (clicked_node->nodetype == e_userfun) {
	    neupositionierung_noetig = 
	      gtk_eval(pDrawExpr, parent, clicked_node,
		       e_lmom, //aktuelle_Auswertungsart(), 
		       1, FALSE, FALSE);
	  } else {
	    neupositionierung_noetig = 
	      gtk_eval(pDrawExpr, parent, clicked_node,
		       aktuelle_Auswertungsart(), 
		       G_MAXINT, FALSE, TRUE);
	  }
	  zuletzt_bearbeitet_abaum = eval_start_node_after_evaluation;
	  zuletzt_bearbeitet_x = (gint)x;
	  zuletzt_bearbeitet_y = (gint)y;
	}
	break;

      case(MITTLERE_MAUSTASTE):
	if ( (clicked_node->nodetype == e_constant) &&
	     ( (clicked_node->valuetype == real_type_index)       ||
	       (clicked_node->valuetype == string_type_index)     ||
	       (clicked_node->valuetype == list_type_index)  ) &&
	     (event->type == GDK_BUTTON_PRESS) 
	   ) {
	  expr_node_fuer_geoeffnetes_popup = clicked_node;
	  adk_fuer_geoeffnetes_popup   = pDrawExpr;
	  pMisc = clicked_node->misc;
	  baumfenster->pop_adjustment->value = pMisc->max_drawn_digits;
	  pMisc = NULL;
	  baumfenster->pop_adjustment->upper=
	    (clicked_node->valuetype == real_type_index)   ?
	    MAXIMALE_NACHKOMMASTELLEN:
	    (clicked_node->valuetype == string_type_index) ?
	    MAXIMALE_ANZAHLZEICHENIMSTRING:
	    MAXIMALE_ANZAHLELEMENTEINLISTE;
	  gtk_adjustment_value_changed(baumfenster->pop_adjustment);

	  gtk_menu_popup(GTK_MENU(baumfenster->popup_menu),NULL,NULL,
			 NULL,NULL,event->button,event->time);
	}
	break;

      default:
	break;
      } //switch

    } else { 

      /* Klick hat ueber keinem Knoten stattgefunden. */
     if (maustaste == MITTLERE_MAUSTASTE) {
       neupositionierung_noetig = 
	 gtk_eval(pDrawExpr, parent, pDrawExpr->act_expr,
		  e_lmim/*aktuelle_Auswertungsart()*/, 
		  G_MAXINT, TRUE, FALSE);
       zuletzt_bearbeitet_abaum = NULL;
       zuletzt_bearbeitet_x = 0;
       zuletzt_bearbeitet_y = 0;
     } //if MITTLERE_MAUSTASTE
    } //if clicked_node != NULL
    if (neupositionierung_noetig) {
      /* Neupositionierung der Knoten und Erstellen des Baumes */
      position_drawableExpr(pDrawExpr, baumfenster);
    }
  } //if pDrawExpr != NULL && drawingAllowed
  if (pDrawExpr == NULL) {
    printf("pDrawExpr == NULL\n");
  } else if (pDrawExpr->drawingAllowed == FALSE) {
    printf("pDrawExpr->drawingAllowed == FALSE\n");
  }

  kiel_debug_out(10,"untersuche_mausklick");
}


void button_press_event(GtkWidget *widget,GdkEventButton *event)
{ 
  kiel_debug_in(10,"button_press_event");
 
  if (warnungs_fenster_geoeffnet()) beep();
  else {
    if (baumfenster->pix_draw->pixm)
      switch(event->button){
        case(1):untersuche_mausklick(event,LINKE_MAUSTASTE,
                                     hole_markierten_Ausdruck());
                break; 
        case(2):untersuche_mausklick(event,MITTLERE_MAUSTASTE,
                                     hole_markierten_Ausdruck());
                break;
        case(3):untersuche_mausklick(event,RECHTE_MAUSTASTE,
                                     hole_markierten_Ausdruck());
                break;
        default:break;
      }
  }

  kiel_debug_out(10,"button_press_event");
}

gint mktz=0;

/* Pixmap in bentigter Gre erzeugen */
void 
baumfenster_configure_event(GtkWidget *widget, GdkEventConfigure *event)
{
  GdkRectangle update_rect; 
  gdouble value_alt;
  //Expr_node_ptr adk = hole_markierten_Ausdruck();
  Drawable_expr_ptr pDrawExpr;

  kiel_debug_in(10,"baumfenster_configure_event");

  //if ((adk)/*&&(adk->baum)&&(adk->Spaltenbreite)*/)
  {
    //printf("CONFIGURE %d\n",mktz);

   if (baumfenster_groessenaenderung_zulassen) {
      if (!bin_in_adjustment_value_changed_callback) {
mktz++;
        baumfenster->adjustmenth->upper = baumfenster->daten_breite; 
        baumfenster->adjustmenth->page_size =
          baumfenster->sw_frame->allocation.width -4;
        baumfenster->adjustmenth->page_increment =
          baumfenster->adjustmenth->page_size / 2; 
        value_alt = baumfenster->adjustmenth->value;
        gtk_adjustment_changed(baumfenster->adjustmenth);
        gtk_adjustment_set_value(baumfenster->adjustmenth, value_alt);
        if ( (baumfenster->adjustmenth->value > 0) &&
             (baumfenster->adjustmenth->value > baumfenster->adjustmenth->upper
                                     - baumfenster->adjustmenth->page_size) ) {
          baumfenster->adjustmenth->value = 
	    MAX(0, baumfenster->adjustmenth->upper - 
		   baumfenster->adjustmenth->page_size);
	} //if
        baumfenster->adjustmentv->upper = baumfenster->daten_hoehe; 
        baumfenster->adjustmentv->page_size =
          baumfenster->sw_frame->allocation.height -4;
        baumfenster->adjustmentv->page_increment =
          baumfenster->adjustmentv->page_size / 2;
        value_alt = baumfenster->adjustmentv->value;
        gtk_adjustment_changed(baumfenster->adjustmentv);
        gtk_adjustment_set_value(baumfenster->adjustmentv, value_alt);
        if ( (baumfenster->adjustmentv->value>0) &&
             (baumfenster->adjustmentv->value>baumfenster->adjustmentv->upper -
	      baumfenster->adjustmentv->page_size) ) {
          baumfenster->adjustmentv->value=MAX(0,
                                          baumfenster->adjustmentv->upper-
                                          baumfenster->adjustmentv->page_size);
	} //if
mktz--;
      } //if (!bin_in_adjustment_value_changed_callback)
if (mktz==0) {  
      if (baumfenster->pix_draw->pixm) {
        gdk_pixmap_unref(baumfenster->pix_draw->pixm);
      }
      baumfenster->pix_draw->pixm = gdk_pixmap_new(widget->window,
						   widget->allocation.width,
						   widget->allocation.height,
						   -1);

      gdk_draw_rectangle(baumfenster->pix_draw->pixm,
                         widget->style->white_gc,
                         TRUE, 0, 0,
                         widget->allocation.width,
			 widget->allocation.height);

    /* Linien zum berprfen der Gre */  
      /*
      gdk_draw_line(baumfenster->pix_draw->pixm,
                    widget->style->mid_gc[0],
                    0-baumfenster->adjustmenth->value,
                    0-baumfenster->adjustmentv->value,
                    baumfenster->daten_breite-baumfenster->adjustmenth->value,
                    baumfenster->daten_hoehe-baumfenster->adjustmentv->value); 
      gdk_draw_line(baumfenster->pix_draw->pixm,
                    widget->style->mid_gc[0],
                    0-baumfenster->adjustmenth->value,
                    baumfenster->daten_hoehe-baumfenster->adjustmentv->value,
                    baumfenster->daten_breite-baumfenster->adjustmenth->value,
                    0-baumfenster->adjustmentv->value);
      */
      pDrawExpr = hole_markierten_Ausdruck();
      if (pDrawExpr != NULL) {
	drawDrawableExpr(pDrawExpr, zuletzt_bearbeitet_abaum/*markedNode*/, 
			 baumfenster);
      } //if
      update_rect.x=0;
      update_rect.y=0;
      update_rect.width=widget->allocation.width;
      update_rect.height=widget->allocation.height;

      if ( (hole_markierten_Ausdruck()) && (zuletzt_bearbeitet_abaum) &&
	   (zuletzt_bearbeitet_x>=0) ) {
	gint anforderung_x,anforderung_y;
	anforderung_x=
	  (gint)baumfenster->adjustmenth->value +
	  getExprPixelmiddle_x(zuletzt_bearbeitet_abaum) -
	  zuletzt_bearbeitet_x;

	zuletzt_bearbeitet_x = -1;
 
	anforderung_y=
	  (gint)baumfenster->adjustmentv->value +
	  getExprPixelmiddle_y(zuletzt_bearbeitet_abaum) -
	  zuletzt_bearbeitet_y;
	/* Damit gtk_adjustment_set_value nicht selber clampt */
	baumfenster->adjustmenth->upper = baumfenster->daten_breite;

	gtk_adjustment_set_value(baumfenster->adjustmenth,
				 (gdouble)CLAMP(anforderung_x,
						0,
						baumfenster->daten_breite -
						widget->allocation.width));

	/* Damit gtk_adjustment_set_value nicht selber clampt */
	baumfenster->adjustmentv->upper=baumfenster->daten_hoehe;
	
	gtk_adjustment_set_value(baumfenster->adjustmentv,
				 (gdouble)CLAMP(anforderung_y,
						0,
						baumfenster->daten_hoehe -
						widget->allocation.height));
      } //if

      gtk_widget_draw(widget,&update_rect);

} //if (mktz==0)
    } //if (baumfenster_groessenaenderung_zulassen)
  } //if (adk)

  kiel_debug_out(10,"baumfenster_configure_event");
}


void baumfenster_expose_event(GtkWidget *widget,GdkEventExpose *event,
                              PIXMAP_DRAWINGAREA_DATEN_TYP eventdata)
{
  //AUSDRUCK_TYP adk=hole_markierten_Ausdruck();

  kiel_debug_in(16,"baumfenster_expose_event");

//  if ((adk)&&(adk->baum)&&(adk->Spaltenbreite)) {
  {
    //printf("EXPOSE %d \n",mktz);  

    gdk_draw_pixmap(widget->window,
                    widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
                    eventdata->pixm,
                    event->area.x,event->area.y,
                    event->area.x,event->area.y,
                    event->area.width,event->area.height);

  }

  kiel_debug_out(16,"baumfenster_expose_event");
}


void diallabel_value_changed_callback(GtkAdjustment *adjustment,
                                      GtkWidget *label)
{
  gchar *text;

  kiel_debug_in(10,"diallabel_value_changed_callback");

  text = g_strdup_printf("%d", (gint)adjustment->value);
  gtk_label_set(GTK_LABEL(label), text);
  g_free(text);

  kiel_debug_out(10,"diallabel_value_changed_callback");
}


void dial_gewaehlt_callback()
{
  Expr_node_misc_ptr pMisc;

  kiel_debug_in(10,"dial_gewaehlt_callback");

  pMisc = expr_node_fuer_geoeffnetes_popup->misc;
  pMisc->max_drawn_digits = (gint)baumfenster->pop_adjustment->value;
  pMisc = NULL;
  expr_node_fuer_geoeffnetes_popup = NULL;

  position_drawableExpr(adk_fuer_geoeffnetes_popup, baumfenster);
  adk_fuer_geoeffnetes_popup = NULL;

  kiel_debug_out(10,"dial_gewaehlt_callback");
}


void baumfenster_setze_groessenaenderung_zulassen(gboolean zulassen)
{
  kiel_debug_in(10,"baumfenster_setze_groessenaenderung_zulassen");
 
  baumfenster_groessenaenderung_zulassen=zulassen;
  gtk_window_set_policy(GTK_WINDOW(baumfenster->fenster), zulassen ,zulassen,
                                                          FALSE);
  gtk_widget_set_usize(baumfenster->fenster,
                       baumfenster->fenster->allocation.width,
                       baumfenster->fenster->allocation.height);

  kiel_debug_out(10,"baumfenster_setze_groessenaenderung_zulassen");
}


void adjustment_value_changed_callback(GtkAdjustment *adjustment)
{
  kiel_debug_in(10,"adjustment_value_changed_callback");
//puts("VALUE CHANGED");
  bin_in_adjustment_value_changed_callback=TRUE;
  baumfenster_configure_event(baumfenster->pix_draw->draw_a,NULL);
  bin_in_adjustment_value_changed_callback=FALSE;

  kiel_debug_out(10,"adjustment_value_changed_callback");
}


void setze_zuletzt_bearbeitet_abaum_auf_NULL()
{
  kiel_debug_in(10,"setze_zuletzt_bearbeitet_abaum_auf_NULL");

  zuletzt_bearbeitet_abaum=NULL;

  kiel_debug_out(10,"setze_zuletzt_bearbeitet_abaum_auf_NULL");
}


void erzeuge_Baum_Fenster(BAUMFENSTER_TYP bmf)
{
  GtkWidget *baum_vbox;

  kiel_debug_in(10,"erzeuge_Baum_Fenster");
 
  /* Fenster erzeugen, Position setzen */ 
  bmf->fenster = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name(bmf->fenster, "Baumfenster");
  gtk_window_set_title(GTK_WINDOW(bmf->fenster), WINDOW_BAUMFENSTER_TEXT);
  gtk_widget_set_uposition(bmf->fenster, POSITION_BAUMFENSTER_X,
                                         POSITION_BAUMFENSTER_Y);
  gtk_window_set_policy(GTK_WINDOW(bmf->fenster), TRUE, TRUE, FALSE);
  gtk_signal_connect(GTK_OBJECT(bmf->fenster), "delete_event",
                     GTK_SIGNAL_FUNC(Baumfenster_Toggle_Button_aus), NULL);
  gtk_container_border_width(GTK_CONTAINER(bmf->fenster), 5);
 
  /* VBox fr Statuslabel und Scrolled Window erzeugen */
  baum_vbox = gtk_vbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(bmf->fenster), baum_vbox);
  gtk_widget_show(baum_vbox);

  {
    {
      GtkWidget *frame;

      /* Frame fr Statuslabel in VBox erzeugen */
      frame = gtk_frame_new(NULL); 
      gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
      gtk_box_pack_start(GTK_BOX(baum_vbox), frame, FALSE, FALSE, 0);
      gtk_widget_show(frame); 
      /* Statuslabel in Frame erzeugen */
      bmf->statuslabel = gtk_label_new("");
      gtk_misc_set_alignment(GTK_MISC(bmf->statuslabel), 0.0, 0.0);
      gtk_container_add(GTK_CONTAINER(frame), bmf->statuslabel);
      gtk_widget_show(bmf->statuslabel);
    }
    {
      GtkWidget *scrollbarh,*scrollbarv;
      GtkWidget *t_hbox,*t_vbox1,*t_vbox2;
      
      /* T_HBox, T_VBox1 und T_VBox2 erzeugen */
      t_hbox = gtk_hbox_new(FALSE,3);
      gtk_box_pack_start(GTK_BOX(baum_vbox), t_hbox, TRUE, TRUE, 0);
      gtk_widget_show(t_hbox);

      t_vbox1 = gtk_vbox_new(FALSE, 3);
      gtk_box_pack_start(GTK_BOX(t_hbox), t_vbox1, TRUE, TRUE, 0);
      gtk_widget_show(t_vbox1);
 
      t_vbox2 = gtk_vbox_new(FALSE, 3);
      gtk_box_pack_start(GTK_BOX(t_hbox), t_vbox2, FALSE, FALSE, 0);
      gtk_widget_show(t_vbox2);
  
      /* Frame fr Drawing Area erzeugen */
      bmf->sw_frame=gtk_frame_new(NULL);  
      gtk_frame_set_shadow_type(GTK_FRAME(bmf->sw_frame),GTK_SHADOW_IN);
      gtk_box_pack_start(GTK_BOX(t_vbox1),bmf->sw_frame,TRUE,TRUE,0);
      gtk_widget_show(bmf->sw_frame); 

      /* Drawing Area im Frame erzeugen */
      bmf->pix_draw=(PIXMAP_DRAWINGAREA_DATEN_TYP)
                   mtmalloc(sizeof(PIXMAP_DRAWINGAREA_DATEN_STRUCT));
      bmf->pix_draw->draw_a=gtk_drawing_area_new(); 
      gtk_widget_set_usize(bmf->pix_draw->draw_a,BREITE_DRAWING_AREA_BAUM,
                                                 HOEHE_DRAWING_AREA_BAUM);
      gtk_container_add(GTK_CONTAINER(bmf->sw_frame),bmf->pix_draw->draw_a);
      gtk_widget_show(bmf->pix_draw->draw_a);
      /* Callbacks setzen*/
      /**/
      gtk_signal_connect(GTK_OBJECT(bmf->pix_draw->draw_a),"expose_event",
                         GTK_SIGNAL_FUNC(baumfenster_expose_event),
                         bmf->pix_draw);
      /**/
      gtk_signal_connect(GTK_OBJECT(bmf->pix_draw->draw_a),
                         "configure_event",
                         GTK_SIGNAL_FUNC(baumfenster_configure_event),
                         NULL);
      /**/
      gtk_signal_connect(GTK_OBJECT(bmf->pix_draw->draw_a),
                         "button_press_event",
                         GTK_SIGNAL_FUNC(button_press_event),NULL);
      /**/
      /* zu betrachtende Events setzen */
      gtk_widget_set_events(bmf->pix_draw->draw_a,GDK_EXPOSURE_MASK| 
                                                  GDK_LEAVE_NOTIFY_MASK| 
                                                  GDK_BUTTON_PRESS_MASK);

      /* Datenausmae initialisieren */
      bmf->daten_breite=0;
      bmf->daten_hoehe=0;
  
      /* Scrollbar horizontal */   
      bmf->adjustmenth=GTK_ADJUSTMENT(gtk_adjustment_new(0,0,64,10,32,64));
      scrollbarh=gtk_hscrollbar_new(bmf->adjustmenth);
      gtk_box_pack_start(GTK_BOX(t_vbox1),scrollbarh,FALSE,TRUE,0);
      gtk_signal_connect(GTK_OBJECT(bmf->adjustmenth),"value_changed",
                         GTK_SIGNAL_FUNC(adjustment_value_changed_callback),
                         NULL);
      gtk_widget_show(scrollbarh);          

      /* Scrollbar vertikal */   
      bmf->adjustmentv=GTK_ADJUSTMENT(gtk_adjustment_new(0,0,42,10,21,42));
      scrollbarv=gtk_vscrollbar_new(bmf->adjustmentv);
      gtk_box_pack_start(GTK_BOX(t_vbox2),scrollbarv,TRUE,TRUE,0);
      gtk_signal_connect(GTK_OBJECT(bmf->adjustmentv),"value_changed",
                         GTK_SIGNAL_FUNC(adjustment_value_changed_callback),
                         NULL);
      gtk_widget_show(scrollbarv);

      /* Dummy fr rechte untere Ecke */
      { 
        GtkWidget *dummy;

        dummy=gtk_label_new("");
        gtk_widget_set_usize(dummy,scrollbarv->requisition.width,
                                   scrollbarh->requisition.height);
        gtk_box_pack_start(GTK_BOX(t_vbox2),dummy,FALSE,FALSE,0);
        gtk_widget_show(dummy);
      }
    }
  }

  /* Popup-Men fr mittlere Maustaste erzeugen */
  {
    GtkWidget *eintrag;
    GtkWidget *vbox;
    GtkWidget *frame;
    GtkWidget *dial;
    GtkWidget *label;

    bmf->popup_menu=gtk_menu_new();

    eintrag=gtk_menu_item_new();
    gtk_menu_append(GTK_MENU(bmf->popup_menu),eintrag);
    gtk_signal_connect_object(GTK_OBJECT(eintrag),"activate",
                              GTK_SIGNAL_FUNC(dial_gewaehlt_callback),NULL);
    gtk_widget_show(eintrag);
    /* VBox in Popup-Men */
    vbox=gtk_vbox_new(FALSE,5);
    gtk_container_add(GTK_CONTAINER(eintrag),vbox);
    gtk_widget_show(vbox);
 
    /* Frame oben in VBox */
    frame=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
    gtk_box_pack_start(GTK_BOX(vbox),frame,TRUE,TRUE,0);
    gtk_widget_show(frame);
 
    /* Adjustment fr Dial */
    bmf->pop_adjustment=GTK_ADJUSTMENT(gtk_adjustment_new(0,0,
                                                     MAXIMALE_NACHKOMMASTELLEN,
                                                          1,10,0));
    /* Dial in Frame */
    dial=gtk_dial_new(bmf->pop_adjustment);
    gtk_dial_set_update_policy(GTK_DIAL(dial),GTK_UPDATE_DELAYED);
    gtk_widget_set_usize(dial,DURCHMESSER_NACHKOMMASTELLEN_DIAL,
                              DURCHMESSER_NACHKOMMASTELLEN_DIAL);
    gtk_container_add(GTK_CONTAINER(frame),dial);
    gtk_widget_show(dial);

    /* Label unten in die VBox */
    label=gtk_label_new("-");
    gtk_box_pack_start(GTK_BOX(vbox),label,TRUE,TRUE,0);
    gtk_widget_show(label);
    /* Erst hier, da Label gendert werden soll */
    gtk_signal_connect(GTK_OBJECT(bmf->pop_adjustment),"value_changed",
                       GTK_SIGNAL_FUNC(diallabel_value_changed_callback),
                       label);

  }

  /* ggf. anzeigen */
  if (BUTTON_AUSDRUCKBAUM_FENSTER_STATUS) gtk_widget_show(bmf->fenster);

  kiel_debug_out(10,"erzeuge_Baum_Fenster");
}


void 
position_drawableExpr(Drawable_expr_ptr pDrawExpr, BAUMFENSTER_TYP bmf)
{
  kiel_debug_in(10,"position_drawableExpr");

  if (pDrawExpr != NULL) {
    set_WethSha_parameters(K_KnotenMindestabstand, K_Zeilenhoehe, 
			   getExprPixelheight(pDrawExpr->act_expr, bmf));
    prepareForWethSha(pDrawExpr);
    wetherellShannon(pDrawExpr, bmf);
    //adk->Zeichnen_erlaubt = TRUE;

    bmf->daten_breite = pDrawExpr->totalPixelwidth;
    bmf->daten_hoehe  = pDrawExpr->totalPixelheight;
  } else {
    bmf->daten_breite = 0;
    bmf->daten_hoehe  = 0;
  } //if pExpr != NULL

  /* Baum neu zeichnen und Gre richtig setzen */
  baumfenster_configure_event(bmf->pix_draw->draw_a, NULL);

  Zeichenreihenlabel_aktualisieren();

  kiel_debug_out(10,"position_drawableExpr");
} //position_drawableExpr


/* Like position_drawableExpr() but without WetherellShannon-Algorithmus, 
 * because positioning is allready correct. 
 */
void 
freshen_positioning(Drawable_expr_ptr pDrawExpr, BAUMFENSTER_TYP bmf)
{
  kiel_debug_in(10,"freshen_positioning");

  if (pDrawExpr != NULL) {
    calcPixelwidthAndHeight(pDrawExpr, bmf);
    bmf->daten_breite = pDrawExpr->totalPixelwidth;
    bmf->daten_hoehe  = pDrawExpr->totalPixelheight;
  } else {
    bmf->daten_breite = 0;
    bmf->daten_hoehe  = 0;
  } //if pExpr != NULL

  /* Baum neu zeichnen und Gre richtig setzen */
  baumfenster_configure_event(bmf->pix_draw->draw_a, NULL);

  Zeichenreihenlabel_aktualisieren();

  kiel_debug_out(10,"freshen_positioning");
}
