/* UEbersichts Fenster */
#include "kiel_global.h"

#include "kiel_gtk_uef.h"
#include "kiel_gtk_uef_priv.h"
#include "kiel_gtk_fenster.h"
#include "kiel_gtk_bmf.h"
#include "kiel_fkt.h"
#include "kiel_gtk.h"
#include "kiel_ressource.h"
#include "../Syntaxtree/syntaxtree.h"
#include "drawable_expr.h"


Drawable_expr_ptr hole_markierten_Ausdruck()
{
  Drawable_expr_ptr erg;
  GList*        selection_list;
  GtkObject*    list_item;

  kiel_debug_in(10,"hole_markierten_Ausdruck");

  if (!adkuebersichtsfenster) {
    erg = NULL;
  } else {
    selection_list = GTK_LIST(adkuebersichtsfenster->liste)->selection;
    /* in selection_list ist maximal ein Element, da GTK_SELECTION_SINGLE */
    if (!selection_list) {
      erg = NULL;
    } else {
      list_item = GTK_OBJECT(selection_list->data);
      erg = gtk_object_get_user_data(list_item);
    }
  }

  kiel_debug_out(10,"hole_markierten_Ausdruck");
  return(erg);
}


Fun_node_ptr hole_markierte_Rechenvorschrift()
{
  Fun_node_ptr erg;
  GList*       selection_list;
  GtkObject*   list_item;

  kiel_debug_in(10,"hole_markierte_Rechenvorschrift");

  if (!adkuebersichtsfenster) {
    erg = NULL;
  } else {
    selection_list = GTK_LIST(rvuebersichtsfenster->liste)->selection;
    /* in selection_list ist maximal ein Element, da GTK_SELECTION_SINGLE */
    if (!selection_list) {
      erg = NULL;
    } else {
      list_item = GTK_OBJECT(selection_list->data);
      erg = gtk_object_get_user_data(list_item);
    }
  }

  kiel_debug_out(10,"hole_markierte_Rechenvorschrift");
  return(erg);
}


void uebersicht_selektiert(GtkList *gtklist,gpointer *welches)
{
  BAUMFENSTER_TYP *bmfensterP;
  Drawable_expr_ptr adk;
  Fun_node_ptr  rv;

  kiel_debug_in(10,"uebersicht_selektiert");

  if (warnungs_fenster_geoeffnet()) {
    beep();
  } else {
    switch(GPOINTER_TO_INT(welches)) {
    case(UEBERSICHTSFENSTER_AUSDRUCK): 
      bmfensterP = hole_adresse_von_baumfenster();

      setze_statuslabel("");
      /* in selection_list ist maximal ein Element, da GTK_SELECTION_SINGLE*/
      adk = hole_markierten_Ausdruck();
      if (adk) {
	gchar* str;

	Baumfenster_Toggle_Button_an();
	str = exprNode2String(adk->initial_expr);
g_print("Ausdruck : %s\n",str);
        mtfree(str);
	//      }

      /* Neupositionierung der Knoten und Erstellen des Baumes */
      position_drawableExpr(adk, *bmfensterP);
      }
      UndoRedo_ProgressBar_und_MaxLabel_aktualisieren(adk);
      break;

    case(UEBERSICHTSFENSTER_RECHENVORSCHRIFT):
      rv = hole_markierte_Rechenvorschrift();
      if (rv) {
	gchar* sig = funNode2Signature(rv);
g_print("RV : %s \n", sig);
        mtfree(sig); 
      }

      break;

    default:
      puts("exit in switch ::uebersicht_selektiert");
      gtk_exit(1);
    } //switch
  }

  kiel_debug_out(10,"uebersicht_selektiert");
}


void uef_button_press_event(GtkWidget *gtklist,GdkEventButton *event,
                            gpointer *welches)
{
  Drawable_expr_ptr adk;
  Fun_node_ptr  rv;
  gchar *entry_text;
  AUSDRUCKEINGABEFENSTER_TYP *ausdruckeingabefensterP;
  gchar *neuer_string;

  kiel_debug_in(10,"uef_button_press_event");
  
  if (warnungs_fenster_geoeffnet()) {
    beep();
  } else { 
    if (event->button == 3/*rechte Maustaste*/) { 
      switch(GPOINTER_TO_INT(welches)){
      case(UEBERSICHTSFENSTER_AUSDRUCK): 
	ausdruckeingabefensterP = hole_adresse_von_ausdruckeingabefenster();
	//entry_text = 
	//  gtk_entry_get_text(GTK_ENTRY((*ausdruckeingabefensterP)->entry));

	adk = hole_markierten_Ausdruck();
	if (adk){
	  gchar* tmp_str;

	  tmp_str = exprNode2String(adk->initial_expr);
	  neuer_string = mtstrconcat(2, tmp_str, ";");
	  mtfree(tmp_str);
	  gtk_entry_set_text(GTK_ENTRY((*ausdruckeingabefensterP)->entry),
			     neuer_string); 
	  mtfree(neuer_string);
	  gtk_widget_show((*ausdruckeingabefensterP)->fenster);
	}
	break;

      case(UEBERSICHTSFENSTER_RECHENVORSCHRIFT):
	ausdruckeingabefensterP = hole_adresse_von_ausdruckeingabefenster();
	entry_text = 
	  gtk_entry_get_text(GTK_ENTRY((*ausdruckeingabefensterP)->entry));

	rv = hole_markierte_Rechenvorschrift();
	if (rv != NULL) {
	  gint akt_pos;
	  gchar* s_vor, *brackets, *s_nach;
	  gint within_brackets;

	  akt_pos  = 
	    GTK_EDITABLE((*ausdruckeingabefensterP)->entry)->current_pos;
	  s_vor        = mtstrdup(entry_text);
	  s_vor[akt_pos] = '\0';
	  s_nach       = mtstrdup(&entry_text[akt_pos]);
	  if ( (rv->nodetype == e_constructor) && 
	       (((GList*)rv->paramslist)->data == NULL) ) {
	    brackets = "";
	    within_brackets = 0;
	  } else {
	    brackets = "()";
	    within_brackets = 1;
	  }
	  neuer_string = mtstrconcat(4, s_vor, rv->fun_id, brackets, s_nach);
	  gtk_entry_set_text(GTK_ENTRY((*ausdruckeingabefensterP)->entry),
			     neuer_string);
	  brackets = NULL; //don not free! it is a constant string
	  mtmultifree(3, s_vor, s_nach, neuer_string);
	  gtk_entry_set_position(GTK_ENTRY((*ausdruckeingabefensterP)->entry),
				 akt_pos +strlen(rv->fun_id) +within_brackets);
	  gtk_widget_show((*ausdruckeingabefensterP)->fenster);
	}
	break;

      default:
	puts("exit in switch ::uebersicht_selektiert");
	gtk_exit(1);
      } //switch
    } //if rechte Maustaste
  }

  kiel_debug_out(10,"uef_button_press_event");
}


void erzeuge_Uebersichts_Fenster(UEBERSICHTSFENSTER_TYP uef,gint fenster_id)
{
  kiel_debug_in(10,"erzeuge_Uebersichts_Fenster");

  /* Fenster erzeugen, Position setzen */
  uef->fenster=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  switch(fenster_id){
    case(UEBERSICHTSFENSTER_AUSDRUCK): 
      gtk_window_set_title(GTK_WINDOW(uef->fenster),
                           WINDOW_ADKUEBERSICHTSFENSTER_TEXT);
      gtk_widget_set_uposition(uef->fenster,POSITION_ADKUEBERSICHTSFENSTER_X,
                                            POSITION_ADKUEBERSICHTSFENSTER_Y);
      gtk_signal_connect(GTK_OBJECT(uef->fenster),"delete_event",
                     GTK_SIGNAL_FUNC(ADK_Uebersichtsfenster_Toggle_Button_aus),
                         NULL);
      break;
    case(UEBERSICHTSFENSTER_RECHENVORSCHRIFT):
      gtk_window_set_title(GTK_WINDOW(uef->fenster),
                           WINDOW_RVUEBERSICHTSFENSTER_TEXT);
      gtk_widget_set_uposition(uef->fenster,POSITION_RVUEBERSICHTSFENSTER_X,
                                            POSITION_RVUEBERSICHTSFENSTER_Y);
      gtk_signal_connect(GTK_OBJECT(uef->fenster),"delete_event",
                      GTK_SIGNAL_FUNC(RV_Uebersichtsfenster_Toggle_Button_aus),
                         NULL);
      break;
    default:puts("exit in switch ::erzeuge_Uebersichts_Fenster");
            gtk_exit(1);
  }
  gtk_container_border_width(GTK_CONTAINER(uef->fenster),5);

  /* Liste mit Label erzeugen */
  {
    GtkWidget *vbox;
  
    /* VBox erzeugen */
    vbox=gtk_vbox_new(FALSE,0);
    gtk_container_add(GTK_CONTAINER(uef->fenster),vbox);
    gtk_widget_show(vbox);

    {
      GtkWidget *label,*scrolled_win;

      /* Label erzeugen */  
      switch(fenster_id){
        case(UEBERSICHTSFENSTER_AUSDRUCK):
          label=gtk_label_new(LABEL_AUSDRUECKE);
          break;
        case(UEBERSICHTSFENSTER_RECHENVORSCHRIFT):
          label=gtk_label_new(LABEL_RECHENVORSCHRIFTEN);
          break;
        default:
	  label = NULL; //only to avoid a compiler warning
	  puts("exit in switch ::erzeuge_Uebersichts_Fenster2");
	  gtk_exit(1);
      }
      gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,0);
      gtk_widget_show(label);
      /* Scrolled Window erzeugen */
      scrolled_win=gtk_scrolled_window_new(NULL,NULL);
      gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win),
                                     GTK_POLICY_AUTOMATIC,
                                     GTK_POLICY_AUTOMATIC);
      gtk_widget_set_usize(scrolled_win,BREITE_UEBERSICHTS_SCROLLED_WIN,
                           HOEHE_UEBERSICHTS_SCROLLED_WIN);
      gtk_box_pack_start(GTK_BOX(vbox),scrolled_win,TRUE,TRUE,0);
      gtk_widget_show(scrolled_win);
      /* darein eine Liste */
      uef->liste=gtk_list_new();
      gtk_scrolled_window_add_with_viewport(
        GTK_SCROLLED_WINDOW(scrolled_win),uef->liste);  
      gtk_signal_connect(GTK_OBJECT(uef->liste),"selection_changed",
                         GTK_SIGNAL_FUNC(uebersicht_selektiert),
                         GINT_TO_POINTER(fenster_id));
      gtk_list_set_selection_mode(GTK_LIST(uef->liste),GTK_SELECTION_SINGLE);
      gtk_signal_connect(GTK_OBJECT(uef->liste),"button_press_event",
                         GTK_SIGNAL_FUNC(uef_button_press_event),
                         GINT_TO_POINTER(fenster_id));
      gtk_widget_show(uef->liste);
    }
  }

  /* ggf. anzeigen */
  if (((fenster_id==UEBERSICHTSFENSTER_AUSDRUCK)&&
       (BUTTON_MLAUSDRUCK_UEBERSICHT_STATUS)) ||
      ((fenster_id==UEBERSICHTSFENSTER_RECHENVORSCHRIFT)&&
       (BUTTON_RV_UEBERSICHT_STATUS)) 
     )
    gtk_widget_show(uef->fenster);

  kiel_debug_out(10,"erzeuge_Uebersichts_Fenster");
}

/*
static void 
free_expr_overview(UEBERSICHTSFENSTER_TYP uef)
{
  kiel_debug_in(10, "free_expr_overview");

  kiel_debug_out(10, "free_expr_overview");
} //free_expr_overview


void 
gibfrei_Uebersichts_Fenster(UEBERSICHTSFENSTER_TYP uef)
{
  kiel_debug_in(10,"gibfrei_Uebersichts_Fenster");

  if (uef == adkuebersichtsfenster) {
    free_expr_overview(uef);
  } //if
  mtfree(uef);

  kiel_debug_out(10,"gibfrei_Uebersichts_Fenster");
} //gibfrei_Uebersichts_Fenster
*/

