#include "kiel_global.h"

#include "kiel_gtk.h"
#include "kiel_gtk_wf.h"
#include "kiel_gtk_wf_priv.h"
#include "kiel_gtk_fenster.h"

  #include "kiel_fkt.h"

#include "kiel_ressource.h"
#include "../Misc/error_interface.h"

void warnung_button_callback(GtkWidget *w,WARNUNGRUECKGABE_TYP data)
{  
  UNDOREDOFENSTER_TYP *undoredofensterP;
  AUSDRUCKEINGABEFENSTER_TYP *ausdruckeingabefensterP;
  AUSWERTUNGSFENSTER_TYP *auswertungsfensterP;

  kiel_debug_in(10,"warnung_button_callback");

  clear_ErrorDescription();
  gtk_widget_destroy(data->fenster);

  undoredofensterP=hole_adresse_von_undoredofenster();
  ausdruckeingabefensterP=hole_adresse_von_ausdruckeingabefenster();
  auswertungsfensterP=hole_adresse_von_auswertungsfenster();

  gtk_entry_set_editable(GTK_ENTRY((*undoredofensterP)->entry_zurueck),TRUE);
  gtk_entry_set_editable(GTK_ENTRY((*undoredofensterP)->entry_vor),TRUE);
  gtk_entry_set_editable(GTK_ENTRY((*ausdruckeingabefensterP)->entry),TRUE);
  gtk_entry_set_editable(GTK_ENTRY((*auswertungsfensterP)->entry),TRUE);

  habe_warnungs_fenster_geschlossen();

  letzte_warnung_auswahl=data->nr;

  /* Die anderen knnen leider nicht gefreet werden. */
  mtfree(data);

  kiel_debug_out(10,"warnung_button_callback");
}


gint Warnung_auf_Antwort_warten()
{
  gint erg;

  kiel_debug_in(10,"Warnung_auf_Antwort_warten");

  while (warnungs_fenster_geoeffnet())
    while (gtk_events_pending()) gtk_main_iteration();

  erg=letzte_warnung_auswahl;  

  kiel_debug_out(10,"Warnung_auf_Antwort_warten");
  return(erg);
}


void Warnungs_Fenster_oeffnen(gint anz_button,...)
/* Die ersten anz_button gchars nach anz_button sind die Button-Labels. */
/* Danach folgen die Textzeilen (NULL-terminiert).                      */
{
  GtkWidget *window;
  GtkWidget *vbox1;
  BEFEHLSFENSTER_TYP *befehlsfensterP; 
  UNDOREDOFENSTER_TYP *undoredofensterP;
  AUSDRUCKEINGABEFENSTER_TYP *ausdruckeingabefensterP;
  AUSWERTUNGSFENSTER_TYP *auswertungsfensterP;
  gchar *string;
  va_list args;

  kiel_debug_in(10,"Warnungs_Fenster_oeffnen");

  beep();

  habe_warnungs_fenster_geoeffnet();
  
  befehlsfensterP=hole_adresse_von_befehlsfenster();
  undoredofensterP=hole_adresse_von_undoredofenster();
  ausdruckeingabefensterP=hole_adresse_von_ausdruckeingabefenster();
  auswertungsfensterP=hole_adresse_von_auswertungsfenster();

  gtk_entry_set_editable(GTK_ENTRY((*undoredofensterP)->entry_zurueck),FALSE);
  gtk_entry_set_editable(GTK_ENTRY((*undoredofensterP)->entry_vor),FALSE);
  gtk_entry_set_editable(GTK_ENTRY((*ausdruckeingabefensterP)->entry),FALSE);
  gtk_entry_set_editable(GTK_ENTRY((*auswertungsfensterP)->entry),FALSE);


  radio_auswahl_bei_warnung_ausw_art=
    (GTK_TOGGLE_BUTTON((*auswertungsfensterP)->button_auswertungsart[0])
                                                           ->active)?0:
    (GTK_TOGGLE_BUTTON((*auswertungsfensterP)->button_auswertungsart[1])
                                                           ->active)?1:2;
  radio_auswahl_bei_warnung_schritte=
    (GTK_TOGGLE_BUTTON((*auswertungsfensterP)->button_schritte[0])->active)?0:
    (GTK_TOGGLE_BUTTON((*auswertungsfensterP)->button_schritte[1])->active)?1:
    (GTK_TOGGLE_BUTTON((*auswertungsfensterP)->button_schritte[2])->active)?2:
    (GTK_TOGGLE_BUTTON((*auswertungsfensterP)->button_schritte[3])->active)?3:
                                                                            4;

  /* Fenster erzeugen, Position setzen */
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL); 
  gtk_window_set_title(GTK_WINDOW(window), WINDOW_WARNUNGSFENSTER_TEXT);
  gtk_signal_connect(GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(beep),
                     NULL);
  gtk_container_border_width(GTK_CONTAINER(window),5);
  gtk_widget_set_uposition(window,
			   POSITION_WARNUNGSFENSTER_X,
			   POSITION_WARNUNGSFENSTER_Y);

 
  /* Neue Vbox1 */
  vbox1=gtk_vbox_new(FALSE,5);
  gtk_container_border_width(GTK_CONTAINER(vbox1),5);
  gtk_container_add(GTK_CONTAINER(window),vbox1);
  gtk_widget_show(vbox1); 

  va_start(args,anz_button); 

  {
    GtkWidget *hbox;
  
    /* HBox unten in die Vbox1 */
    hbox=gtk_hbox_new(TRUE,5);
    gtk_container_border_width(GTK_CONTAINER(hbox),5);
    gtk_box_pack_end(GTK_BOX(vbox1),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox);
 
    {
      GtkWidget *button;
      gint i;
      WARNUNGRUECKGABE_TYP rueckgabe;

      for(i=0;i<anz_button;i++) {
        string=va_arg(args,gchar*);

        rueckgabe=(WARNUNGRUECKGABE_TYP)mtmalloc(sizeof(
                                                     WARNUNGRUECKGABE_STRUCT));
        rueckgabe->fenster=window;
        rueckgabe->nr=i;

        /* Buttons in die Hbox */
        button=gtk_button_new_with_label(string);
        gtk_signal_connect(GTK_OBJECT(button),"clicked",
                           GTK_SIGNAL_FUNC(warnung_button_callback),rueckgabe);
        gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,5);
        gtk_widget_show(button);
      }
    }
  }

  {
    GtkWidget *hbox;
  
    /* HBox oben in die Vbox1 */
    hbox=gtk_hbox_new(FALSE,5);
    gtk_container_border_width(GTK_CONTAINER(hbox),5);
    gtk_box_pack_start(GTK_BOX(vbox1),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox);
    
    {
      GtkWidget *pixmapwidget;
      GdkPixmap *pixmap;
      GdkBitmap *mask;
      GtkStyle *style;

      /* links in die HBox ein groes Ausrufungs- bzw. Fragezeichen */
      style=gtk_widget_get_style((*befehlsfensterP)->fenster);
      pixmap=gdk_pixmap_create_from_xpm_d((*befehlsfensterP)->fenster->window,
                                          &mask,&style->bg[GTK_STATE_NORMAL],
                                          (anz_button<2)?
                                            (gchar **)ausrufungszeichen:
                                            (gchar **)fragezeichen );
      pixmapwidget=gtk_pixmap_new(pixmap,mask);
      gtk_box_pack_start(GTK_BOX(hbox),pixmapwidget,FALSE,FALSE,10);
      gtk_widget_show(pixmapwidget);
    }
     
    {
      GtkWidget *vbox2;
      GtkWidget *label;
      
      /* Vbox rechts in die HBox */
      vbox2=gtk_vbox_new(FALSE,5);
      gtk_container_border_width(GTK_CONTAINER(vbox2),5);
      gtk_box_pack_end(GTK_BOX(hbox),vbox2,FALSE,FALSE,0);
      gtk_widget_show(vbox2);

      /* Alle gewnschten Zeilen als Label in die VBox */
      string=va_arg(args,gchar*);
      while(string) {
        label=gtk_label_new(string);
        gtk_box_pack_start(GTK_BOX(vbox2),label,FALSE,FALSE,0);
        gtk_widget_show(label);
  
        string=va_arg(args,gchar *);
      }
    }
  }

  va_end(args);

  /* Fenster anzeigen */
  gtk_widget_show(window);

  kiel_debug_out(10,"Warnungs_Fenster_oeffnen");
}


