#include<gtk/gtk.h>
#include "kiel_gtk.h"
#include "../Misc/my_dbug.h"
#include "../Misc/mem_management.h"
#include "expr_node_misc.h"
#include "drawable_expr.h"
#include "undoredo.h"



void 
free_undoredo_list(GList* list)
{
  GList* tmp;

  DBUG_ENTER("free_undoredo_list");
  for (tmp = list;  tmp != NULL;  tmp = g_list_next(tmp)) {
    free_expr_node_inclusiv_misc(tmp->data);
    tmp->data = NULL;
  } //for tmp
  g_list_free(list);

  DBUG_VOID_RETURN;
} //free_undoredo_list


void 
singleUndo(Drawable_expr_ptr pDrawExpr)
{
  Expr_node_ptr tmp;

  DBUG_ENTER("singleUndo");

  if ((pDrawExpr != NULL) && (pDrawExpr->undo_list != NULL)) {
    pDrawExpr->redo_list = g_list_prepend(pDrawExpr->redo_list, 
					  pDrawExpr->act_expr);
    tmp = pDrawExpr->undo_list->data;
    pDrawExpr->act_expr = tmp;
    pDrawExpr->undo_list = g_list_remove(pDrawExpr->undo_list, tmp);
    //Baum neu aufbauen
  } //if

  DBUG_VOID_RETURN;
} //singleUndo


void 
singleRedo(Drawable_expr_ptr pDrawExpr)
{
  Expr_node_ptr tmp;

  DBUG_ENTER("singleRedo");

  if ((pDrawExpr != NULL) && (pDrawExpr->redo_list != NULL)) {
    pDrawExpr->undo_list = g_list_prepend(pDrawExpr->undo_list, 
					  pDrawExpr->act_expr);
    tmp = pDrawExpr->redo_list->data;
    pDrawExpr->act_expr = tmp;
    pDrawExpr->redo_list = g_list_remove(pDrawExpr->redo_list, tmp);
    //Baum neu aufbauen
  } //if

  DBUG_VOID_RETURN;
} //singleRedo


void 
undo(Drawable_expr_ptr pDrawExpr, gint undo_steps)
{
  gint i;

  DBUG_ENTER("undo");

  for (i=0;  i < undo_steps;  i++) {
    singleUndo(pDrawExpr);
  } //for i
  //update UndoRedo-window
  UndoRedo_ProgressBar_und_MaxLabel_aktualisieren(pDrawExpr);

  DBUG_VOID_RETURN;
} //undo


void 
redo(Drawable_expr_ptr pDrawExpr, gint redo_steps)
{
  gint i;

  DBUG_ENTER("redo");

  for (i=0;  i < redo_steps;  i++) {
    singleRedo(pDrawExpr);
  } //for i
  //update UndoRedo-window
  UndoRedo_ProgressBar_und_MaxLabel_aktualisieren(pDrawExpr);

  DBUG_VOID_RETURN;
} //redo
