//
// C++ Interface: window_options
//
// Description: 
//
//
// Author: pm <pm@ariva.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//

#include "../Misc/mem_management.h"
#include <stdio.h>

typedef struct WindowOptionsStruct
{
  int      pos_x;
  int      pos_y;
  int      width;
  int      height;
  int      visible;
} WIN_OPTIONS_STRUCT;
typedef WIN_OPTIONS_STRUCT *WIN_OPTIONS;


typedef struct OptionsStruct
{
  WIN_OPTIONS bf;
  WIN_OPTIONS aef;
  WIN_OPTIONS awf;
  WIN_OPTIONS bmf;
  WIN_OPTIONS uef;
  WIN_OPTIONS urf;
  WIN_OPTIONS wf;
  WIN_OPTIONS zrf;
  WIN_OPTIONS ueber_rv;
  WIN_OPTIONS ueber_ex;
} OPTIONS_STRUCT;
typedef OPTIONS_STRUCT *OPTIONS;


WIN_OPTIONS win_options_new();
WIN_OPTIONS win_options_new_from_fd(FILE *fd);
void win_options_save_to_fd(WIN_OPTIONS opt, FILE *fd);

OPTIONS options_new();
OPTIONS options_new_from_fd(FILE *fd);
void options_save_to_fd(OPTIONS opt, FILE *fd);
  
void options_load();
void options_save();
