#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "utilities.h"
#include "my_dbug.h"
#include "mem_management.h"
//#include "../GTK/kiel_gtk_wf.h"
#include "error_interface.h"



typedef struct {
  gint   nr_buttons;
  gchar* buttonlabel1;
  gchar* line0;
  gchar* line1;
  gchar* line2;
  gchar* line3;
  gchar* line4;
  gchar* line5;
} ErrorDescription_struct, *ErrorDescription_ptr;



static ErrorDescription_ptr pErrorDesc = NULL;


gint 
getErrorDescription_nr_buttons(void)
{
  DBUG_ENTER("getErrorDescription_nr_buttons");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->nr_buttons);
} //getErrorDescription_nr_buttons


gchar* 
getErrorDescription_buttonlabel1(void)
{
  DBUG_ENTER("getErrorDescription_buttonlabel1");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->buttonlabel1);
} //getErrorDescription_buttonlabel1


gchar* 
getErrorDescription_line0(void)
{
  DBUG_ENTER("getErrorDescription_line0");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->line0);
} //getErrorDescription_line0


gchar* 
getErrorDescription_line1(void)
{
  DBUG_ENTER("getErrorDescription_line1");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->line1);
} //getErrorDescription_line1


gchar* 
getErrorDescription_line2(void)
{
  DBUG_ENTER("getErrorDescription_line2");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->line2);
} //getErrorDescription_line2


gchar* 
getErrorDescription_line3(void)
{
  DBUG_ENTER("getErrorDescription_line3");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->line3);
} //getErrorDescription_line3


gchar* 
getErrorDescription_line4(void)
{
  DBUG_ENTER("getErrorDescription_line4");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->line4);
} //getErrorDescription_line4


gchar* 
getErrorDescription_line5(void)
{
  DBUG_ENTER("getErrorDescription_line5");
  DBUG_ASSERT(pErrorDesc != NULL);

  DBUG_RETURN(pErrorDesc->line5);
} //getErrorDescription_line5


gboolean 
isErrorDescriptionClear(void)
{
  DBUG_ENTER("isErrorDescriptionClear");

  DBUG_RETURN(pErrorDesc == NULL);
} //isErrorDescriptionClear


/** Frees all used resources of the ErrorDescription.
  */
void
clear_ErrorDescription(void)
{
  DBUG_ENTER("clear_ErrorDescription");

  if (pErrorDesc != NULL) {
    pErrorDesc->nr_buttons = 0;
    MTFREENULL(pErrorDesc->buttonlabel1);
    MTFREENULL(pErrorDesc->line0);
    MTFREENULL(pErrorDesc->line1);
    MTFREENULL(pErrorDesc->line2);
    MTFREENULL(pErrorDesc->line3);
    MTFREENULL(pErrorDesc->line4);
    MTFREENULL(pErrorDesc->line5);
    MTFREENULL(pErrorDesc);
  }
 
  DBUG_VOID_RETURN;
} //clear_ErrorDescription


void
set_ErrorDescription(
  gint   nr_buttons, gchar* buttonlabel1,
  gchar* line0, gchar* line1, gchar* line2,
  gchar* line3, gchar* line4, gchar* line5)
{

  DBUG_ENTER("set_ErrorDescription");

  clear_ErrorDescription();
  pErrorDesc = mtmalloc(sizeof(ErrorDescription_struct));
  pErrorDesc->nr_buttons   = nr_buttons;
  pErrorDesc->buttonlabel1 = mtstrdup(buttonlabel1);
  pErrorDesc->line0        = mtstrdup(line0);
  pErrorDesc->line1        = mtstrdup(line1);
  pErrorDesc->line2        = mtstrdup(line2);
  pErrorDesc->line3        = mtstrdup(line3);
  pErrorDesc->line4        = mtstrdup(line4);
  pErrorDesc->line5        = mtstrdup(line5);

  DBUG_VOID_RETURN;
} //set_ErrorDescription



void
printf_ErrorDescription(void)
{
  FILE* fh = stderr;

  DBUG_ENTER("printf_ErrorDescription");

  fprintf(fh, "%s\n", pErrorDesc->line0);
  fprintf(fh, "%s\n", pErrorDesc->line1);
  fprintf(fh, "%s\n", pErrorDesc->line2);
  fprintf(fh, "%s\n", pErrorDesc->line3);
  fprintf(fh, "%s\n", pErrorDesc->line4);
  fprintf(fh, "%s\n", pErrorDesc->line5);
  fprintf(fh, "Buttonlabel1: %s\n", pErrorDesc->buttonlabel1);

  DBUG_VOID_RETURN;
} //printf_ErrorDescription

/*
void
show_ErrorDescription(void)
{
  DBUG_ENTER("show_ErrorDescription");

  Warnungs_Fenster_oeffnen(gerErrorDescription_nr_buttons(), 
			   gerErrorDescription_buttonlabel1(),
			   gerErrorDescription_line0(), 
			   gerErrorDescription_line1(), 
			   gerErrorDescription_line2(), 
			   gerErrorDescription_line3(),
			   gerErrorDescription_line4(), 
			   gerErrorDescription_line5(), NULL);

  DBUG_VOID_RETURN;
} //show_ErrorDescription
*/
